//      ==============================================================
//
//      TwinCAD V3.1 Installation Program
//
//      Developed by Kang, Hsin-Min.
//      Copyright (c) 1997, 1998, 1999 TCAM Development House, Co. Ltd.
//
//      This program is written in TCL (TwinCAD Command Language)
//      and must be executed by the TPInstall(tm) executable, which
//      is usually renamed to SETUP.EXE or INSTALL.EXE
//
//      TPInstall(tm) is also developed by Kang, Hsin-Min, and is a
//      copyrighted product of TCAM Development House.
//
//#define DEBUG 1
#define MYVERSION       "TP1.0.4 (May 24, 1999)"
#define TARGET  "Target"
#define SOURCE  "Source"
#define PMITEM  "ProgmanCommand"
#define GENERAL "General Setup"
#define WinINI  ""
#define STDKEY  0x2215
#define NETKEY  0x1580

#define BOOL    int
#define TRUE    1
#define FALSE   0
#define EOF     -1

#define BIG5            0x404
#define GB2312          0x804
#define SJIS            0x411
#define KOREAN          0x412
#define ASCII           0x409

/* Clipboard command messages */
#define WM_CUT              0x0300
#define WM_COPY             0x0301
#define WM_PASTE            0x0302
#define WM_CLEAR            0x0303
#define WM_UNDO             0x0304

#define MB_OK               0x0000
#define MB_OKCANCEL         0x0001
#define MB_ABORTRETRYIGNORE 0x0002
#define MB_YESNOCANCEL      0x0003
#define MB_YESNO            0x0004
#define MB_RETRYCANCEL      0x0005
#define MB_TYPEMASK         0x000F

#define MB_ICONHAND         0x0010
#define MB_ICONQUESTION     0x0020
#define MB_ICONEXCLAMATION  0x0030
#define MB_ICONASTERISK     0x0040
#define MB_ICONMASK         0x00F0

#define MB_ICONINFORMATION  MB_ICONASTERISK
#define MB_ICONSTOP         MB_ICONHAND

#define MAKEINTRESOURCE(n)  "#n"

/* Standard icon resource IDs from Windows */
#define IDI_APPLICATION     MAKEINTRESOURCE(32512)
#define IDI_HAND            MAKEINTRESOURCE(32513)
#define IDI_QUESTION        MAKEINTRESOURCE(32514)
#define IDI_EXCLAMATION     MAKEINTRESOURCE(32515)
#define IDI_ASTERISK        MAKEINTRESOURCE(32516)

/* Standard dialog button IDs */
#define IDOK                1
#define IDCANCEL            2
#define IDABORT             3
#define IDRETRY             4
#define IDIGNORE            5
#define IDYES               6
#define IDNO                7

#define MessageBox MsgBox

/* Useful Device Parameters for DeviceCaps() */
#define HORZSIZE      4
#define VERTSIZE      6
#define HORZRES       8
#define VERTRES       10
#define BITSPIXEL     12
#define PLANES        14
#define NUMCOLORS     24
#define ASPECTX       40
#define ASPECTY       42
#define ASPECTXY      44

#define LOGPIXELSX    88
#define LOGPIXELSY    90

#define SIZEPALETTE  104
#define NUMRESERVED  106
#define COLORRES     108

/* Control window styles */
#define WS_GROUP            0x00020000L
#define WS_TABSTOP          0x00010000L

#define GBTNFLAG        0xf800
#define BTN_ATRB        0x1277
#define ST_ATRBZ        0x0088
#define ST_ATRB         0x00ff
#define ST_ATRBY        0x408f
#define DLG_ATRB        0x3fef

#define ST_GRAYZ        0x00ff
#define ST_GRAY         0x0000
#define ST_GRAYY        0x40f0
#define DLG_GRAY        0x3770

int     nColorDepth = DeviceCaps(0,BITSPIXEL);  // System Color Depth
int     nXres = DeviceCaps(0,HORZRES);          // Screen Resolution
int     nYres = DeviceCaps(0,VERTRES);          // Screen Resolution

int     st_atrby={(nColorDepth>=15)?ST_ATRBY:ST_GRAYY};
int     st_atrbz={(nColorDepth>=15)?ST_ATRBZ:ST_GRAYZ};
int     st_atrb={(nColorDepth>=15)?ST_ATRB:ST_GRAY};
int     dlg_atrb={(nColorDepth>=15)?DLG_ATRB:DLG_GRAY};
int     dlgwnd[]={0,21,0,60,dlg_atrb};
int     copywnd[]={0,12,0,44,dlg_atrb};
//
int     nGlobalTotal=1;
long    lCurrentByte;           // Byte number that has been installed
long    lTotalByte;             // If to use globally

char    szInf[80]="";
char    szUserName[80]="";      // Register User Name
char    szCompany[80]="";
char    szSerial[80]="";
char    szInitSource[128]="";       // Initial Source where Setup is run
char    szTarget[128]="C:\\TWINCAD";
char    szBackup[128]="";
char    szFolder[80]="TwinCAD V3.2";
int     nSubDir;
char    szSubDir[36][16];
int     nDisks;                 // Number of Disks to install
BOOL    nStarted;
int     nLid=os_language();
char    szPID[60]="TwinCAD";
char    szPINI[60]="TwinCAD.INI";
char    szPName[60]="TwinCAD V3.2";
char    szPLogo[60]="TwinCAD.BMP";
char    szPFile[60]="TwinCAD.EXE";
int     nInstalled=0;           // Had been Installed ?
int     nVMajor,nVMinor, nVStep;
//
//      Define useful macro
//
//#define NEEDREDRAW
//#define textout(r,c,s,t) {wnd_static((r)|0x100,(c)|0x100,s,st_atrbz,t);wnd_static(r,c,s,st_atrb,t);}
//
// The 3D effect is now a feature in wnd_static(); however, you can not change
//    such text via wnd_settext() in current release. Meanwhile, wnd_settext()
//    is also modified to update the background automatically if the text is
//    to be drawn transparently. There is no need to redraw the entire window!
//
#define textout(r,c,s,t) {wnd_static((r)|0x100,(c)|0x100,s,st_atrby,t);}
#define set_text(s,i,v) v=get_profile(s,i,szInf,v); if (index(v,"\""))v=eval(v); else v=eval("\""+v+"\"");
//
char    szOkay[20]="&Ok";
char    szCancel[20]="&Cancel";
char    szBack[20]="< &Back";
char    szNext[20]="> &Next";
char    szFinish[20]="&Finish";
char    szYes[20] = "&Yes";
char    szNo[20] = "&No";
char    szBrowse[20]="B&rowse";
char    szResume[20]="&Resume";
char    szExit[20]="E&xit";
//
//      All procedures in the list must return non-zero value!
//      This can aslo be configured in the INF in the future version,
//      if all dialog procedures are standardized.
//
char    szProc[][20]={          // Process sequence in jmp table
        "SetLanguage()",
        "SetInitMsg()",         //jam added on 3.25 2003
        "Register()",
        "Initialization()",     // Initialize ...
        "Welcome()",
        "License()",
        "SetPMGroup()",
        "SetUpTarget()",
        "StartCopy()",          // Confirm informations
        "CreateTarget()",       // Create Target
        "CopyAllDisk()",
        "CopyPcfFile()",        // jam added for PATHCUT
        "ProgramSetup()",
        "InitConfigFile()",     // jam added:2001/03/02
        "XInitConfigFile()",    // jam added:2005/12/06 for ʶ       
        "SetupTpress()",	// jam added:2006/4/27 for TurboPress w
        ""
};

int     main()
{
        int     i;
#ifdef  DEBUG
        $debug(1);              // Set in internal debugging mode
#endif
        userbrk(0);             // Disable user break
        StartUp();
        for(i=0;szProc[i]!="";)
                i += eval(szProc[i]);
        MustDo();
        SentinelDrv();
        RockeyDrv();
        CleanUp();
        Completed();
        Terminate(0);   // Over
}

void    SentinelDrv()
{
        chdrive(takepath(get_source() )+"SENTINEL");
        winexec(takepath(get_source() )+"SENTINEL\\SENTINEL.EXE /USB");
        return;
}

void    RockeyDrv()
{
     // printf("\nPATH2= %s",takepath(get_source() )+"ROCKEY");
        chdrive(takepath(get_source() )+"ROCKEY");
        winexec(takepath(get_source() )+"ROCKEY\\INSTDRV.EXE /i/s");
        return;
}

int     CleanUp()
{
        printf("\n\n** Intallation process is completed.");
        printf(prints("\n   Total %,ld Bytes Written.\n",lCurrentByte));
        set_target(szTarget);
        set_subpath();
        save_log("install.log");
        return 0;
}

int     MustDo()
{
        int     pgmlevel;
        char    szTxt[128];
        pgmlevel = TCADLevel(szSerial);

        switch(pgmlevel) {
          case 1:       DoSection("Standard");  break;
          case 2:       DoSection("NetWork");   break;
          case 0:       DoSection("TestDrive"); break;
          default:
                if ( pgmlevel < 0 )
                        DoSection("Lite");
                break;
        }
        // Copy contact file if present
        szTxt = fullname("CONTACT.TXT",takepath(szInf));
        if ( fexist(szTxt) )
                copyfile(szTxt,fullname("CONTACT.TXT",szTarget),0);
        szTxt = fullname("TESTMODE.TXT",takepath(szInf));
        if ( fexist(szTxt) )
                copyfile(szTxt,fullname("TESTMODE.TXT",szTarget),0);
        return 1;
}

int     DoSection(char szSec[])
{
        int     nMacro;
        int     i, j;
        char    szBuf[512];
        char    szOver[120];

        nMacro = eval(get_profile(szSec,"JobNumber",szInf,"0"));
        if ( nMacro <= 0 ) return 1;

        // Need to convert all '\' into double '\' for string re-evaluation
        szOver = strrplx(szTarget,"\\","\\\\");

        for(i=0;i<nMacro;i++) {
            szBuf = get_profile(szSec,prints("Job%d",i+1),szInf,"");
            if ( szBuf == "" ) continue;
            szBuf = strrplx(szBuf,"%-1+",get_syspath(1)+"\\\\");
            szBuf = strrplx(szBuf,"%-2+",get_syspath(2)+"\\\\");
            szBuf = strrplx(szBuf,"%0+",szOver+"\\\\");
            szBuf = strrplx(szBuf,"%-1",get_syspath(1));
            szBuf = strrplx(szBuf,"%-2",get_syspath(2));
            szBuf = strrplx(szBuf,"%0",szOver);
            for(j=0;j<nSubDir;j++) {
                    if ( !index(szBuf,"%") )
                            break;
                    szBuf = strrplx(szBuf,"%"+prints("%d+",j+1),
                                     szOver+"\\\\"+szSubDir[j]+"\\\\");
                    szBuf = strrplx(szBuf,"%"+prints("%d",j+1),
                                     szOver+"\\\\"+szSubDir[j]);
            }
            if ( $debug() )
                    printf("\nJob%d-> Eval('%s')",i+1,szBuf);
            eval(szBuf);
        }
        return 1;
}

int     CopyAllDisks()
{
        int     i;
        nStarted = 1;
        for(i=0;i<nDisks;i++)
                CopyDisk(i,i);
        if ( nGlobalTotal )
                wndclose();
        return 1;
}

int     CopyPcfFile()
{
        char    szSource[80];
/*      char    subpath[][10]={
                "ARD",
                "OMEGA",
                "SUREFRST",
                "CHMER",
                "JSEDM",
                "CHARMILL",
                "MAXSEE",
                "STD",
                ""
        };   */
        int     i;

        //Only PATHCUT must do
        if (left$(szSerial,1) != "P") return 1;

        set_subpath("PATHCUT");
   //   szTarget=get_target();
        szSource=get_source();
        set_source(szSource);

        switch( left$(szSerial,4) ) {
          case "PCAR" :
//          set_source(szInitSource+"\\ARD");
//          copytarget("*.PCF");
            unpack("ARD.LZH");
            break;
          case "PCOM" :
            unpack("OMEGA.LZH");
            break;
          case "PCSU" :
            unpack("SUREFRST.LZH");
            break;
          case "PCCH" :
            unpack("CHMER.LZH");
            break;
          case "PCJS" :
            unpack("JSEDM.LZH");
            break;
          case "PCCT" :
            unpack("CHARMILL.LZH");
            break;
          case "PCMA" :
            unpack("MAXSEE.LZH");
            break;
          case "PCSO" :
            unpack("SODICK.LZH");
            break;
          case "PCST" :
            unpack("STD.LZH");
            break;
          case "PCJM" :
            unpack("JOEMARS.LZH");
            break;
          case "PCFT" :
            unpack("FINETECH.LZH");
            break;
/*        case "PCAL" :   // ALL PCF
            for (i=0;subpath[i]!="";i++) {
              set_source(get_source()+"\\"+subpath[i]);
              copytarget("*.PCF");
              set_source(szInitSource);
            }
            break;
*/
        }
        return 1;
}

int     InitConfigFile()
{
        char    szSource[80];
        int     i;

        //Only WTCAM must do
        if (left$(szSerial,1) != "W") return 1;

        set_subpath("WTCAM");
        szSource=get_source();
        set_source(szSource);

        //Which menu
        switch( left$(szSerial,2) ) {
          case "WA" :
            switch(os_language()){  // Menu file for local contact
              case BIG5:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamA.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\CwtcamA.MNU",szPINI);
                break;
              case GB2312:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamA.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\BwtcamA.MNU",szPINI);
                break;
              case SJIS:   break;
              case KOREAN: break;
              default:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamP.MNU",szPINI);
                break;
            }
			
            break;
          case "WP" :
            switch(os_language()){  // Menu file for local contact
              case BIG5:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamP.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\CwtcamP.MNU",szPINI);
                break;
              case GB2312:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamP.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\BwtcamP.MNU",szPINI);
                break;
              case SJIS:   break;
              case KOREAN: break;
              default:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamP.MNU",szPINI);
                break;
            }
            break;
          case "WO" :
            switch(os_language()){  // Menu file for local contact
              case BIG5:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamO.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\CwtcamO.MNU",szPINI);
                break;
              case GB2312:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamO.MNU",szPINI);
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\BwtcamO.MNU",szPINI);
                break;
              case SJIS:   break;
              case KOREAN: break;
              default:
                if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
                  put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamO.MNU",szPINI);
                break;
            }
            break;
          default:
            if (get_profile("Default Language","InitialMenuFile",szPINI)=="")
              put_profile("Default Language","InitialMenuFile",szTarget+"\\SUPPORT\\WtcamA.MNU",szPINI);

            switch(os_language()){  // Menu file for local contact
              case BIG5:
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\CwtcamA.MNU",szPINI);
                break;
              case GB2312:
                if (get_profile("Alternate Language","InitialMenuFile",szPINI)=="")
                  put_profile("Alternate Language","InitialMenuFile",szTarget+"\\SUPPORT\\BwtcamA.MNU",szPINI);
                break;
            }
            break;
        }

        //Unzip PCZ file for OEM
        switch( left$(szSerial,4) ) {
          case "WACT" :
            unpack("CHARMILL.LZH");
            break;
          case "WASK" :
            unpack("SODICK.LZH");
            break;
          case "WAMT" :
            unpack("MITSU.LZH");
            break;
          case "WACH" :
            unpack("CHMER-A.LZH");
            break;
          case "WAAX" :
            unpack("AX-A.LZH");
            break;
          case "WASP" : //SPM, 2004.4.26
            unpack("SPM.LZH");
            break;
          case "WAHT" : //HITACHI, 2004.4.27
            unpack("HITACHI.LZH");
            break;
          case "WAFN" : //FANUC, 2005.2.22
            unpack("FANUC.LZH");
            break;
          case "WOAG" :
            unpack("BAGIE.LZH");
            set_subpath("SUPPORT");
            unpack("BagieSup.LZH");
            break;
          case "WOBA" :
            unpack("BACT.LZH");
            set_subpath("SUPPORT");
            unpack("BagieSup.LZH");
            break;
          case "WOAR" :
            unpack("ARD.LZH");
            break;
          case "WOCH" :
            unpack("CHMER.LZH");
            break;
          case "WOFT" :
            unpack("FINETECH.LZH");
            break;
          case "WOJC" :
            unpack("JITEN.LZH");
            break;
          case "WOJM" :
            unpack("JOEMARS.LZH");
            break;
          case "WOJS" :
            unpack("JSEDM.LZH");
            break;
          case "WOMA" :
            unpack("MAXSEE.LZH");
            break;
          case "WOOM" :
            unpack("OMEGA.LZH");
            break;
          case "WOSU" :
            unpack("SUREFRST.LZH");
            break;
          case "WOAX" :
            unpack("ACCUTEX.LZH");
            break;
          case "WOTP" : //TOPEDM, 2004.4.2
            unpack("TOPEDM.LZH");
            break;
          case "WOST" :
            unpack("STD.LZH");
            break;
        }

        return 1;
}

int     XInitConfigFile()
{
	char    szSource[80];
        int     i;

        //Only XTCAM must do
        if (left$(szSerial,1) != "X") return 1;               
		
	//SET INI FILE
        switch( left$(szSerial,2) ) {
          case "XZ":
          	put_profile("General Setup","SignOnBitmap",szTarget+"\\XCDOUBLE.JPG",szPINI);  
        
        	set_subpath(); //ܴܦwˮڥؿ        
        	szSource=get_source();
        	set_source(szSource);  	          	          	        
		unpack("XCDOUBLE.LZH"); //LOGO
		
		//ʶ
		set_subpath("XTCAM");
		unpack("CDB_CODE.LZH"); //[uNX		
		
		//ѨMɦWD: ARJ(Windows)NɦWs@۰ʸY
		//yk:ARJ a -je YɦW *.*(Y)
            	//]wYؼХؿ                        	
            		            
            	chdrive(szTarget+"\\XTCAM"); 		//ܦw˺Ϻ, EX: F: --> C:            	
            	winexec(szSource+"\\CDOUBLE.EXE -y"); 	//Ѽy: yes            	            	            	

		break;	
	  default: //@Xf
	  	set_subpath("XTCAM");
		unpack("XPC.LZH"); //XPC, XPE	  
		break;		  	
	}
	
	return 1;
}

//wTurboPress, קאּH۰ʸYɦwTurboPress -- 2006.4.27
int     SetupTpress()
{
	char    szSource[80];
        int     i;

        //Only TPRESS must do
        if (left$(szSerial,1) != "U") return 1;                           		            
               
        //R Support U EPC
        remove(szTarget+"\\Support\\TCAD.EPC");
        remove(szTarget+"\\Support\\CTCAD.EPC");		                              
                
	//ѨMɦW, lؿD: ARJ(Windows)NTPRESSؿUɮפΤlؿs@۰ʸY
	//yk:ARJ a TPRESS(YɦW) *.* -je -r
        //]wYؼХؿ                        	        

	szSource=get_source();                    
        chdrive(szTarget+"\\TPRESS"); 		//ܦw˺Ϻ, EX: F: --> C:            	
        winexec(szSource+"\\TPRESS.EXE -y"); 	//Ѽy: yes            	            	            	
	
	return 1;
}

int     PutProfile()
{
        printf("\n ******************************************************* ");
        printf("\n* Don't change/erase/move this installation log, if you *");
        printf("\n* are going  to un-install  the product  at later time. *");
        printf("\n* The TCAM un-installer depends on its content to work. *");
        printf("\n *******************************************************");
        printf("\n== Installation Profile ==================================");
        printf("\n ........Product ID: %s",szPID);
        printf("\n ......Product Name: %s",szPName);
        printf("\n ....ProductVersion: %d.%d.%03d",nVMajor,nVMinor,nVStep);
        printf("\n .........User Name: %s",szUserName);
        printf("\n ......Company Name: %s",szCompany);
        printf("\n ....Product Serial: %s",szSerial);
        printf("\n ...........OS Type: %d",os_type());
        printf("\n .......OS Language: %04xh",os_language());
        printf("\n .Installation Date: %s",date$());
        printf("\n .Installation Time: %s",time$());
        printf("\n ......Control File: %s",szInf);
        printf("\n .......INSTALL.TCL: %s",MYVERSION);
        if ( nInstalled )
        printf("\n ..LastInstallation: %s",get_profile(szPID,"InstallDate",WinINI,"N/A"));
        if ( nInstalled )
        printf("\n LastProductVersion: %s",get_profile(SOURCE,"ProductVersion",szInf,"N/A"));
        printf("\n==========================================================");
        return 1;
}

int     StartUp()
{
        char    szInf[80];
        char    szTemp[80];

        nStarted = 0;
        szInf = fullname("INSTMSG.INF",get_source());
        szPID = get_profile(SOURCE,"ProductID",szInf,szPID);
        szPINI = get_profile(SOURCE,"ProductProfile",szInf,szPID+".INI");
        szPName= get_profile(SOURCE,"ProductName",szInf,szPName);
        szPLogo= get_profile(SOURCE,"ProductLogo",szInf,szPLogo);
        szPFile= get_profile(SOURCE,"ProductFile",szInf,szPFile);
        szUserName = get_profile(GENERAL,"User",szPINI);
        szCompany = get_profile(GENERAL,"Organization",szPINI);
        szTarget = get_profile(szPID,"InstallPath",WinINI);
        szInitSource = get_source();   // Save Initial Source
        nInstalled = 0;
        if ( szTarget != "" ) {
                if ( fexist(fullname(szPFile,szTarget)) )
                        nInstalled = 1;
        }
        szTemp = get_profile(SOURCE,"ProductVersion",szInf);
        sscanf(szTemp,"%d.%d.%d",&nVMajor,&nVMinor,&nVStep);

        return 1;
}

void    SetInitMsg()
{
        int     i;
        char    szFile[20];
        char    szButtons[]="Buttons";

        switch(nLid){
                case BIG5:    szFile="CINSTMSG.INF";  break;
                case SJIS:    szFile="JINSTMSG.INF";  break;
                case GB2312:  szFile="BINSTMSG.INF";  break;
                case KOREAN:  szFile="KINSTMSG.INF";  break;
                default:      szFile="INSTMSG.INF";   break;
        }
        szInf = fullname(szFile,get_source());

        // Get Common button text
        set_text(szButtons,"ok",szOkay);
        set_text(szButtons,"Cancel",szCancel);
        set_text(szButtons,"Back",szBack);
        set_text(szButtons,"Next",szNext);
        set_text(szButtons,"Finish",szFinish);
        set_text(szButtons,"yes",szYes);
        set_text(szButtons,"No",szNo);
        set_text(szButtons,"Browse",szBrowse);
        set_text(szButtons,"Resume",szResume);
        set_text(szButtons,"Exit",szExit);

}

//      ==============================================================
//      Initialization -- Copy all necessary files to Temporary Drive
//
int     Initialization()
{
        char    szFile[20];
        char    szTemp[128];
        int     i;

//      SetLanguage();
        SetupInf();

        switch(nLid){  // Our license agreement
          case BIG5:    szFile="clicense.txt";  break;
          case SJIS:    szFile="jlicense.txt";  break;
          case GB2312:  szFile="blicense.txt";  break;
          case KOREAN:  szFile="klicense.txt";  break;
          default:      szFile="license.txt";   break;
        }

        szTemp = fullname(szFile,get_source());
        switch(cb_load(1,szTemp)) {     // Get license agreement into clipboard
          case 0:
                printf("\nFile: '%s' not found",szTemp);
                szTemp = fullname("license.txt",get_source());
                cb_load(1,szTemp);      // Use English instead, if ...
                break;
          case -1:
          case -2:
                printf("\nClipboard I/O error!");   break;
        }
        //
        //      Get Default Target
        //
        szTarget = get_profile(TARGET,"MainDirectory",szInf,szTarget);
        if ( !index(szTarget,":") )     // If no drive spec, ...
                szTarget = fullname(szTarget,get_syspath(3));
        //
        //      Other Default Informations
        //
        szPName= get_profile(SOURCE,"ProductName",szInf,szPName);
        szPLogo= get_profile(SOURCE,"ProductLogo",szInf,szPLogo);
        nDisks = eval(get_profile(SOURCE,"DiskNumber",szInf,"0"));
        nGlobalTotal = eval(get_profile(SOURCE,"TotalCopyMeter",szInf,"1"));
        lCurrentByte = 0L;
        lTotalByte = eval("v1="+get_profile(SOURCE,"TotalSize",szInf,"0"));
        szTemp = get_profile(SOURCE,"ProductVersion",szInf);
        sscanf(szTemp,"%d.%d.%d",&nVMajor,&nVMinor,&nVStep);

        BackGround();

        return 1;
}

int     SetupInf()
{
        int     i;
        char    szFile[20];
        char    szTemp[128], szTxt[128];
        char    szSrc[128], szDst[128];
        char    szButtons[]="Buttons";
//      printf("\nszInf = %s",szInf);
//      if ( szInf != "" )
//              remove(szInf);
        szInf = "";

        switch(left$(szSerial,1)) {
           case "M": // MTCAM
                switch(nLid){
                        case BIG5:    szFile="CMTCAM.INF";  break;
                        case SJIS:    szFile="JMTCAM.INF";  break;
                        case GB2312:  szFile="BMTCAM.INF";  break;
                        case KOREAN:  szFile="KMTCAM.INF";  break;
                        default:      szFile="MTCAM.INF";   break;
                }
                break;
           case "S": // TwinCAD Pro
           case "N": // TwinCAD NET
           case "V": // TwinCAD Lite
                switch(nLid){
                        case BIG5:    szFile="CTWINCAD.INF";  break;
                        case SJIS:    szFile="JTWINCAD.INF";  break;
                        case GB2312:  szFile="BTWINCAD.INF";  break;
                        case KOREAN:  szFile="KTWINCAD.INF";  break;
                        default:      szFile="TWINCAD.INF";   break;
                }
                break;
           case "0": // TwinCAD Evaluation version
                switch(nLid){
                  case BIG5:    szFile="CTWINUNI.INF";  break;
                  case GB2312:  szFile="BTWINUNI.INF";  break;
                  default:      szFile="TWINUNI.INF";   break;
                }
                break;
           case "T": // TwinCAD
                switch(szSerial[1]){
                  case 'P': // TwinCAD Pro
                        switch(nLid){
                                case BIG5:    szFile="CTWINCAD.INF";  break;
                                case SJIS:    szFile="JTWINCAD.INF";  break;
                                case GB2312:  szFile="BTWINCAD.INF";  break;
                                case KOREAN:  szFile="KTWINCAD.INF";  break;
                                default:      szFile="TWINCAD.INF";   break;
                        }
                        break;
                  case 'U': // TwinCAD Uni
                        switch(nLid){
                                case BIG5:    szFile="CTWINUNI.INF";  break;
                                case GB2312:  szFile="BTWINUNI.INF";  break;
                                default:      szFile="TWINUNI.INF";   break;
                        }
                        break;
                }
                break;
           case "W": // WTCAM
                switch(nLid){
                        case BIG5:    szFile="CWTCAM.INF";  break;
                        case SJIS:    szFile="JWTCAM.INF";  break;
                        case GB2312:  szFile="BWTCAM.INF";  break;
                        case KOREAN:  szFile="KWTCAM.INF";  break;
                        default:      szFile="WTCAM.INF";   break;
                }
                break;
           case "P": // PATHCUT
                switch(nLid){
                        case BIG5:    szFile="CPATHCUT.INF";  break;
                        case SJIS:    szFile="JPATHCUT.INF";  break;
                        case GB2312:  szFile="BPATHCUT.INF";  break;
                        case KOREAN:  szFile="KPATHCUT.INF";  break;
                        default:      szFile="PATHCUT.INF";   break;
                }
                break;
           case "U": // TurboPress
                switch(nLid){
                        case BIG5:    szFile="CTPRESS.INF";  break;
                        case SJIS:    szFile="JTPRESS.INF";  break;
                        case GB2312:  szFile="BTPRESS.INF";  break;
                        default:      szFile="TPRESS.INF";   break;
                }
                break;
	   case "X": // XTCAM
		switch(nLid){
                        case BIG5:    szFile="CXTCAM.INF";  break;
                        case GB2312:  szFile="BXTCAM.INF";  break;
                        default:      szFile="XTCAM.INF";   break;
                }		     
		break;
           default: // TwinCAD
                switch(nLid){
                        case BIG5:    szFile="CTWINCAD.INF";  break;
                        case SJIS:    szFile="JTWINCAD.INF";  break;
                        case GB2312:  szFile="BTWINCAD.INF";  break;
                        case KOREAN:  szFile="KTWINCAD.INF";  break;
                        default:      szFile="TWINCAD.INF";   break;
                }
                break;
        }

        szInf = fullname(szFile,get_source());
        szTemp = fullname("TEMP",get_syspath(3));
        if ( !fexist(szTemp,0x10) )     // Do we have a temporary directory?
                szTemp = fullname("TMP",get_syspath(3));
        else if ( upper(szTemp) == upper(get_source()) )
                szTemp = fullname("TMP",get_syspath(3));
        //
        // In case that the user is installing from the temporary directory,
        // don't use that directory for the temporary storage!
        //
        // Uh? ... Yes, It does happen!
        //                                      -- Feb 16, 1998
        if ( !fexist(szTemp,0x10) )     // Do we have Temporary directory?
                szTemp = fullname(szFile,get_syspath(3));
        else if ( upper(szTemp) == upper(get_source()) )
                szTemp = fullname(szFile,get_syspath(3));
        else
                szTemp = fullname(szFile,szTemp);
        //
        // Well, in case that someone should install it from the root of
        // the temporary drive (which is a hard drive), go to hell!
        //

        switch(copyfile(szInf,szTemp,0)) {        // Should not happen!
          case -1:      // Source Error!
                if ( szFile != "INSTMSG.INF" ) {
                        MessageBox("## Can't open file: "+szInf+
                                   "\nNo local language support now."
                                   "Missing file",MB_OK|MB_ICONINFORMATION);
                        szFile = "INSTMSG.INF";
                        szInf = fullname(szFile,get_source());
                        i = copyfile(szInf,szTemp,0);
                        if ( (i!=-1) && (i!=-2) )
                                break;
                }
                MessageBox("## Can't open file: "+szInf,
                           "Installation fails! ",MB_OK|MB_ICONSTOP);
                exit(1);
          case -2:      // Destination Error!
                MessageBox("## Can create file: "+szTemp,
                           "Installation fails! ",MB_OK|MB_ICONSTOP);
                exit(1);
        }
        szInf = szTemp;

        // ** The following program fragment added at Feb 16, 1998

        switch(os_language()){  // Text information for local contact
          case BIG5:    szFile="CCONTACT.TXT";  break;
          case SJIS:    szFile="JCONTACT.TXT";  break;
          case GB2312:  szFile="BCONTACT.TXT";  break;
          case KOREAN:  szFile="KCONTACT.TXT";  break;
          default:      szFile="CONTACT.TXT";   break;
        }
        szTxt = fullname(szFile,get_source());
        szTemp = fullname("CONTACT.TXT",takepath(szTemp));
        if ( fexist(szTxt) )    // Do we have local contact file
                copyfile(szTxt,szTemp,0);

        switch(os_language()){  // Text information for TestDrive
          case BIG5:    szFile="CTMODE.TXT";  break;
          case SJIS:    szFile="JTMODE.TXT";  break;
          case GB2312:  szFile="BTMODE.TXT";  break;
          case KOREAN:  szFile="KTMODE.TXT";  break;
          default:      szFile="TESTMODE.TXT";   break;
        }
        szTxt = fullname(szFile,get_source());
        szTemp = fullname("TESTMODE.TXT",takepath(szTemp));
        if ( fexist(szTxt) )    // Do we have local contact file
                copyfile(szTxt,szTemp,0);

        // ** End of the update

        // Get Common button text
        set_text(szButtons,"ok",szOkay);
        set_text(szButtons,"Cancel",szCancel);
        set_text(szButtons,"Back",szBack);
        set_text(szButtons,"Next",szNext);
        set_text(szButtons,"Finish",szFinish);
        set_text(szButtons,"yes",szYes);
        set_text(szButtons,"No",szNo);
        set_text(szButtons,"Browse",szBrowse);
        set_text(szButtons,"Resume",szResume);
        set_text(szButtons,"Exit",szExit);
//
//      *** Special consideration upon NT Machine with KeyCard Authentication
//
        if ( os_type() == 2 ) {         // Is NT machine
                szDst = get_syspath(1)+"\\System32\\Drivers\\TCAMPORT.SYS";
                szSrc = fullname("TCAMPORT.SYS",get_source());
                if ( fexist(szSrc) && !fexist(szDst) ) {
                        if ( copyfile(szSrc,szDst,0) == -2 ) {
                                MessageBox("## Can't not copy file:\nFrom\t"+szSrc+"\nTo\t"+szDst,
                                "Warnning!! ",MB_OK|MB_ICONEXCLAMATION);
                        }
                }
                szDst = get_syspath(2)+"\\TCAMCARD.EXE";
                szSrc = fullname("TCAMCARD.EXE",get_source());
                if ( fexist(szSrc) && !fexist(szDst) ) {
                        if ( copyfile(szSrc,szDst,0) == -2 ) {
                                MessageBox("## Can't not copy file:\nFrom\t"+szSrc+"\nTo\t"+szDst,
                                "Warnning!! ",MB_OK|MB_ICONEXCLAMATION);
                        }
                }
        }
        return 1;
}

void    BackGround()
{
        wnd_puts("\f",0x0f);
        GUIFont(40,"Times new Roman",0,0,0,7);
        wnd_loct(0x0800,1);
        wnd_bitmap("BMP_TCAMMARK",0x407f,0,0,0xFFFFFFL);
        wnd_loct(0x0c00,10);
        wnd_puts("TCAM Development House",0xab0e);
        GUIFont(20);
        wnd_loct(0x0403,28);
        wnd_puts("Presents",0xa807);
        GUIFont(60);
        wnd_loct(0x0804,13);
        wnd_puts(szPName,0xab0e);
        wnd_loct(0x0807,23);
        wnd_bitmap(szPLogo,0x407f,0,0,0xFFFFFFL);
        wnd_loct(4,1);
        return 1;
}

void    Terminate(int quit)
{
        if ( quit > 0 ) {   // Process cancel request
                if ( !askquit() )
                        return;         // Nothing!!
        }
        // Remove temporary files ...
        if ( nStarted && quit )
                aborted();
//      remove(szInf);
        exit(0);
}

//      ======================================================
//      ProgramSetup() -- Create program groups and so forth
//
//      GroupName has been defined by the use, what we need to
//      know is what to create from the Inf files
//
ProgramSetUp()
{
        int     nItems;
        char    szItem[256];
        char    szBuf[256];
        int     i,j;
        int     hwnd;

        if ( szFolder == "" )
                return 1;       // No Folder will be created
        nItems = eval(get_profile(PMITEM,"CommandNumber",szInf,"0"));
        pm_command("[CreateGroup("+szFolder+")]");
        printf("\nCreateGroup: %s",szFolder);
        for(i=0;i<nItems;i++) {
                szItem = get_profile(PMITEM,prints("Cmd%d",i+1),szInf);
                szItem = strrplx(szItem,"%-1+",get_syspath(1)+"\\");
                szItem = strrplx(szItem,"%-2+",get_syspath(2)+"\\");
                szItem = strrplx(szItem,"%0+",szTarget+"\\");
                szItem = strrplx(szItem,"%-1",get_syspath(1));
                szItem = strrplx(szItem,"%-2",get_syspath(2));
                szItem = strrplx(szItem,"%0",szTarget);
                szItem = strrplx(szItem,"%-3",takepath(get_source()) ); //JAM 2004
                for(j=0;j<nSubDir;j++) {
                        if ( !index(szItem,"%") )
                                break;
                        szItem = strrplx(szItem,"%"+prints("%d+",j+1),
                                         szTarget+"\\"+szSubDir[j]+"\\");
                        szItem = strrplx(szItem,"%"+prints("%d",j+1),
                                         szTarget+"\\"+szSubDir[j]);
                }
                pm_command(szItem);
                printf("\npm_command: %s",szItem);
        }

        put_profile(GENERAL,"User",szUserName,szPINI);
        put_profile(GENERAL,"Organization",szCompany,szPINI);

        szBuf = CheckSerial(szSerial);
        if ( szBuf == "" )
                szBuf = CheckSerial(szSerial,STDKEY);
        else    InstallSerial(szSerial);
        if ( szBuf == "" )
                szBuf = CheckSerial(szSerial,NETKEY);
        else    InstallSerial(szSerial,STDKEY);

        put_profile(GENERAL,"ActivateKey",szBuf,szPINI);

        // Marked what we have installed
        put_profile(szPID,"InstallPath",szTarget,WinINI);
        put_profile(szPID,"InstallDate",prints("%s",date$()),WinINI);
        put_profile(szPID,"ProductVersion",prints("%d.%d.%d",nVMajor,nVMinor,nVStep),WinINI);

        hwnd = FindWindow("TextBox");
        redraw(hwnd);   // So as to avoid strange display in Chinese mode

        return 1;
}
//      ===============================================================
//      License() -- Asking for software license agreement
//
#define WM_KEYDOWN          0x0100
#define WM_KEYUP            0x0101
#define WM_CHAR             0x0102
#define WM_USER             0x0400
#define EM_SETREADONLY          (WM_USER+31)
#define ES_WANTRETURN       0x00001000L

int     License()
{
        int     i, bBack, bYes, bNo, bEdit, wid;
        int     hwnd;
        char    buf[120];
        char    szSec[]="LicenseAgreement";
        char    szTitle[80];
        char    szMsg1[256];
        char    szMsg2[256];

        szTitle = get_profile(szSec,"Title",szInf,"Software License Agreement");
        szMsg1 = "Please read the following License Agreement.  Press the <PgDn> key to see the rest of the agreement.";
        szMsg2 = "Do you accept all the terms of the preceding License Agreement?  If you choose No,  Setup will terminate.  To install TwinCAD, you must accept this agreement.";
        set_text(szSec,"Msg1",szMsg1);
        set_text(szSec,"Msg2",szMsg2);

        wid = wndopen(dlgwnd,szTitle,0xb21e,0x8000);
        wnd_loct(0x800,1);
        wnd_bitmap("ICON_SETUP",0x407f,0,0,0xFFFFFFL);
        textout(0x0801,8,0x0234,szMsg1);
        bEdit = wnd_editbox(12,1,0x0a3a,0x5004,"");
        textout(0x080f,1,0x0338,szMsg2);
        memset(buf,'_',sizeof(buf));
        buf[58] = 0;
        wnd_loct(0x0810,4);
        wnd_puts(buf,0x8600);
        bBack = wnd_button(0x1811,24,0x108,BTN_ATRB,szBack);
        bYes= wnd_button(0x1811,36,0x108,BTN_ATRB,szYes);
        bNo = wnd_button(0x1811,50,0x108,BTN_ATRB,szNo);
        hwnd = wnd_handle(bEdit);
        SendMessage(hwnd,EM_SETREADONLY,0,0L);  // Set Writable
        SendMessage(hwnd,WM_PASTE,0,0L);
        SendMessage(hwnd,EM_SETREADONLY,1,0L);  // Set Readonly
        wnd_style(hwnd,ES_WANTRETURN,3);        // Remove the flag
        i = wnd_state(bEdit);
        for(i=0;i<10;i++)               // Page Up 10 times
                SendMessage(hwnd,WM_KEYDOWN,0x21,0x490001L);

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        wnd_state(bEdit,i|0x8080);      // Set input focus
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bYes:
                wndclose();
                return 1;
              case 0:
              case -1:
              case bNo:
                Terminate(1);
                continue;
              case bBack:
                wndclose();
                return -1;
              default:
                continue;
            }
        }
}

int     bNext, bBack, bCancel;
int     comdlg(char Title[],int type)
{
        char    buf[120];
        int     wid;

        wid = wndopen(dlgwnd,Title,0xb21e,0x8000);

        wnd_loct(0x800,0xfc01);

        wnd_bitmap((nColorDepth>=15)?"BMP_TCADIMAGE":"BMP_TCADIMAGE256",0x2080,0,0);
/*
        switch(nLid){
          case BIG5:
            wnd_bitmap("BMP_INTERNET",0x2080,0,0);
            break;
          default:
            wnd_bitmap("BMP_INSTALL",0x2080,0,0);
            break;
        }
*/
        memset(buf,'_',sizeof(buf));
        buf[58] = 0;
        wnd_loct(0x0810,4);
        wnd_puts(buf,0x8600);

        switch(type) {
          case 1:
                bNext = wnd_button(0x1811,50,0x108,BTN_ATRB,szFinish);
                bBack = 0;
                bCancel = 0;
                wnd_state(bNext,1,0x8080);      // Default
                return wid;
          case -1:
                bNext = wnd_button(0x1811,36,0x108,BTN_ATRB,szNext);
                bCancel = wnd_button(0x1811,50,0x108,BTN_ATRB,szCancel);
                bBack = 0;
                wnd_state(bNext,1,0x8080);      // Default
                return wid;
        }
        bBack = wnd_button(0x1811,24,0x108,BTN_ATRB,szBack);
        bNext = wnd_button(0x1811,36,0x108,BTN_ATRB,szNext);
        bCancel = wnd_button(0x1811,50,0x108,BTN_ATRB,szCancel);
        wnd_state(bNext,1,0x8080);              // Set Default
        return wid;
}
//
int     SetUpTarget()
{
        int     i, wid;
        char    szBuf[128];
        char    szMessage[384];
        char    szAvail[80];
        int     bSource, bTarget;
        int     bBrowse;
        int     bSize;
        char    szSec[]="SetTarget";

        wid = comdlg(get_profile(szSec,"Title",szInf,"Choose Destination Location"),0);

        szMessage =
        "Setup will install TwinCAD in the following directory."+
        "\n\nTo install to this directory, click [Next]."+
        "\n\nTo install to a different directory, click [Browse] and select another directory.\n\n";
        szBuf = "You can choose not to install TwinCAD, by clicking [Cancel]";

        set_text(szSec,"Msg1",szMessage);
        set_text(szSec,"Msg2",szBuf);
        szMessage += szBuf;
        textout(0x0809,17,0x0a28,szMessage);

        szBuf = get_profile(szSec,"Text1",szInf,"Destination Directory");
        wnd_group(11,18,40,1,0x8260,szBuf,0x830e);
        bTarget = wnd_editbox(12,18,0x0128,0xc080,szTarget);
        bBrowse= wnd_button(15,50,0x108,BTN_ATRB,szBrowse);

        szAvail = "Space Available: %,ld Kb";
        set_text(szSec,"Msg3",szAvail);
        bSize = wnd_static(14,18,0x0128,st_atrb|0x8000,prints(szAvail,diskfree(szTarget)));
#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bNext:
                szTarget = wnd_settext(bTarget);
                wnd_settext(bSize,prints(szAvail,diskfree(szTarget)));
                redraw(wid);
                if ( diskfree(szTarget) < ((lTotalByte/1024L)+256) ) {
                    szMessage = "Available space in the destination drive is not enough to install TwinCAD.\n\n";
                    szMessage+= "You need %,ld KB available space to install TwinCAD.\n\n";
                    szMessage+= "Do you want to proceed the installation on that drive ?";
                    set_text(szSec,"Msg4",szMessage);
                    i = MessageBox(prints(szMessage,lTotalByte/1024),
                        get_profile(szSec,"Text2",szInf,"Disk space not enough!"),MB_YESNO|MB_ICONEXCLAMATION);
                    if ( i != IDYES )
                        continue;
                }
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                szTarget = wnd_settext(bTarget);
                wndclose();
                return -1;
              case bBrowse:
                szTarget = wnd_settext(bTarget);
                szBuf = getpath(szTarget,0,
                        get_profile(szSec,"Text3",szInf,"Please indicate destination directory"));
                if ( szBuf != "" )
                        szTarget = szBuf;
                wnd_settext(bTarget,szTarget);
                wnd_settext(bSize,prints(szAvail,diskfree(szTarget)));
#ifdef  NEEDREDRAW
                redraw(wid);
#endif
                continue;
              default:
                continue;
            }
            break;
        }
        wndclose();
        return 0;       // Cancel
}

int     askquit()
{
        int     wnd[]={0,14,0,50,0xb77f};
        int     bResume, bExit;
        int     i, wid;
        int     atrb, atrbz, atrby;
        char    szMsg[256];
        char    szSec[]="QuitSetup";

        atrb = st_atrb;  atrbz = st_atrbz;  atrby = st_atrby;
        st_atrb = 0x0000; st_atrbz = 0x00ff;  st_atrby = 0x40f0;
        wid = wndopen(wnd,get_profile(szSec,"Title",szInf,"Quit Setup?"),0xb21e,0x8000);
        wnd_loct(0x800,1);
        wnd_bitmap("ICON_SETUP",0x407f,0,0,0xFFFFFFL);

        szMsg = "Setup is not complete.  If you quit the Setup program now, software will not be installed.";
        set_text(szSec,"Msg1",szMsg);
        textout(0x0802,8,0x0327,szMsg);

        szMsg = "You may run the Setup program at a later time to complete the installation.";
        set_text(szSec,"Msg2",szMsg);
        textout(0x0c04,8,0x0227,szMsg);

        szMsg = "To continue installing software, click [Resume].  To quit the Setup program, click [Exit].";
        set_text(szSec,"Msg3",szMsg);
        textout(0x1007,8,0x0327,szMsg);

        bResume = wnd_button(0x100a,15,0x108,BTN_ATRB,szResume);
        bExit = wnd_button(0x100a,27,0x108,BTN_ATRB,szExit);

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        st_atrb = atrb;  st_atrbz = atrbz;  st_atrby = atrby;
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case 0:
              case -1:
              case bResume:
                wndclose();
                return 0;
              case bExit:
                wndclose();
                return 1;
            }
        }
}
//
int     Welcome()
{
        int     i, wid;
        char    szMsg[256];
        char    szSec[]="Welcome";

        wid = comdlg(get_profile(szSec,"Title",szInf,"Welcome"),0);

        szMsg = "Welcome to the TwinCAD Setup program.  This program will install TwinCAD on your computer.";
        set_text(szSec,"Msg1",szMsg);
        textout(0x0801,17,0x0228,szMsg);

        szMsg = "Version:";
        set_text(szSec,"Text1",szMsg);
        wnd_static(0x0403,17,0x0109,st_atrb|0x200,szMsg);
        wnd_static(0x0403,27,0x0108,st_atrb,prints("%d.%d.%03d",nVMajor,nVMinor,nVStep));

        szMsg = "Requires %,ld KB";
        set_text(szSec,"Text2",szMsg);
        wnd_static(0x0403,36,0x0119,st_atrb,prints(szMsg,lTotalByte/1024));

        szMsg = "It is strongly recommended that you exit all Windows programs before running this Setup program.";
        set_text(szSec,"Msg2",szMsg);
        textout(7,17,0x0328,szMsg);

        szMsg = "WARNING: This program is protected by copyright law and international treaties. ";
        set_text(szSec,"Msg3",szMsg);
        textout(10,17,0x0328,szMsg);

        szMsg = "Unauthorized reproduction or distribution of this program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under law.";
        set_text(szSec,"Msg4",szMsg);
        textout(14,17,0x0528,szMsg);

        szMsg = "Click [Cancel] to quit Setup and then close any programs you have running.  Click [Next] to continue with the Setup program.";
        set_text(szSec,"Msg5",szMsg);
        textout(17,17,0x0328,szMsg);

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        ChkInstall();

        wnd_state(bNext,1,0x8080);      // In case ChkInstall() change focus

        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bNext:
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                wndclose();
                return -2; // "return -1" modified to "return -2"
              default:
                continue;
            }
        }
}


int     Register()
{
        int     i, wid;
        int     bUser, bCompany, bSerial;
        char    szSec[]="UserInformation";
        char    szMsg[256];

        wid = comdlg(get_profile(szSec,"Title",szInf,"User Information"),0);

        szMsg = "Type your name below. You must also type the name of the company you work for and the product serial number.";
        set_text(szSec,"Msg1",szMsg);
        textout(0x0802,17,0x0328,szMsg);

        wnd_static(6,17,0x010c,st_atrb|0x200,get_profile(szSec,"Text1",szInf,"N&ame: "));
        bUser = wnd_editbox(6,30,0x011c,0xc080,szUserName);
        wnd_static(9,17,0x010c,st_atrb|0x200,get_profile(szSec,"Text2",szInf,"C&ompany: "));
        bCompany = wnd_editbox(9,30,0x011c,0xc080,szCompany);
        wnd_static(12,17,0x010c,st_atrb|0x200,get_profile(szSec,"Text3",szInf,"&Serial: "));
        bSerial = wnd_editbox(12,30,0x011c,0xc080,szSerial);
#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bNext:
                szUserName = wnd_settext(bUser);
                szCompany = wnd_settext(bCompany);
                szSerial = wnd_settext(bSerial);
                if ( szUserName == "" ) {
                        szMsg = "You must enter your name.";
                        set_text(szSec,"Msg2",szMsg);
                        MessageBox(szMsg,
                                   "Missing User Name!",MB_OK|MB_ICONEXCLAMATION);
                        continue;
                }
                if ( ChkSerial() )
                        continue;
                //
                //      Add Checking code here!
                //
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                szUserName = wnd_settext(bUser);
                szCompany = wnd_settext(bCompany);
                szSerial = wnd_settext(bSerial);
                wndclose();
                return -1;
              default:
                continue;
            }
        }
}

int     ChkSerial()
{
        char    szTitle[80];
        char    szMsg[256];
        char    szSec[]="BadSerial";
        int     i;

        if ( CheckSerial(szSerial)!= "" )
                return 0;       // OKay for Lite Mode version
        if ( CheckSerial(szSerial,STDKEY)!= "" )
                return 0;       // OKay for Standard non-network version
        if ( CheckSerial(szSerial,NETKEY)!= "" )
                return 0;       // OKay for Standard network version

        szTitle = get_profile(szSec,"Title",szInf,"Incorrect Serial Number or Activation Key.");

        szMsg = "You have to enter the correct Serial Number or Activation Key ";
        szMsg+= "to run TwinCAD in either Lite Mode or Standard Mode. Otherwise, ";
        szMsg+= "you can only run it in TestDrive Mode.\n\n";
        szMsg+= "Are you sure to skip this entry? ";

        set_text(szSec,"Msg1",szMsg);
        for(;;) {
                i = MessageBox(szMsg,szTitle,MB_YESNOCANCEL|MB_ICONEXCLAMATION);
                switch(i) {
                  case IDYES:   return 0;
                  case IDNO:    return 1;
                  case IDCANCEL:
                        Terminate(1);
                        continue;
                }
        }
}

int     CheckPath(char path[])
{
        char    szTitle[80];
        char    szMessage[384];
        int     i;
        char    szSec[]="NewDirectory";

        if ( fexist(path,0x10) & 0x10 )
                return 2;       // Ok!

        szTitle = get_profile(szSec,"Title",szInf,"Confirm New Directory");
        szMessage = "You have entered the following directory specification:";
        szMessage += "\n\n\t%s\n\n";
        szMessage += "This directory does not exist. Should Setup create it for you?";

        set_text(szSec,"Msg1",szMessage);
        szMessage = prints(szMessage,path);

        for(;;) {
                i = MessageBox(szMessage,szTitle,MB_YESNOCANCEL|MB_ICONQUESTION);
                switch(i) {
                  case IDCANCEL:
                        Terminate(1);
                        continue;
                  case IDNO:
                        return -1;
                  case IDYES:
                        if ( mkdir(path) ) {    // Rare case
                                MessageBox("## Can not create directory: "+path,
                                   "Directory Creation Error!",MB_OK|MB_ICONINFORMATION);
                                return -1;
                        }
                        return 1;
                }
        }
}
//      =============================================================
//      StartCopy() -- Confirm information again
//
int     StartCopy()
{
        int     i, bEdit, wid;
        char    szMsg[384];
        char    szSetting[512];
        char    szSec[]="StartCopy";
        int     pgmlevel;
        char    modestr[80];

        wid = comdlg(get_profile(szSec,"Title",szInf,"Start Copying Files"),0);
//
//      Special for TwinCAD
//
        pgmlevel = TCADLevel(szSerial);
        if ( pgmlevel == -9 )           // LitePro, Unlock version
                modestr = get_profile(szSec,"Text3",szInf,"Standard Mode,Single User");
        else if ( pgmlevel < 0 )
                modestr = prints(get_profile(szSec,"Text1",szInf,"Lite Mode Level %d"),-pgmlevel);
        else if ( pgmlevel == 0 )
                modestr = get_profile(szSec,"Text2",szInf,"TestDrive Mode");
        else if ( pgmlevel == 1 )
                modestr = get_profile(szSec,"Text3",szInf,"Standard Mode,Single User");
        else if ( pgmlevel == 2 )
                modestr = get_profile(szSec,"Text4",szInf,"Standard Mode, Network User");
        else    // Not possible case, for the time being
                modestr = get_profile(szSec,"Text5",szInf,"Unknown");

        szSetting = "";
        szSetting+= get_profile(szSec,"Text6",szInf,"Source:      ")+"\t"+get_source()+prints("\t%,ld KB",lTotalByte/1024)+"\r\n";
        szSetting+= get_profile(szSec,"Text7",szInf,"Target:      ")+"\t"+szTarget+prints("\t%,ld KB Free",diskfree(szTarget))+"\r\n";
        szSetting+= get_profile(szSec,"Text8",szInf,"Program Folder:")+"\t"+szFolder+"\r\n";
        szSetting+= get_profile(szSec,"Text9",szInf,"User Name:   ")+"\t"+szUserName+"\r\n";
        szSetting+= get_profile(szSec,"Text10",szInf,"Organization:")+"\t"+((szCompany!="")?szCompany:"N/A")+"\r\n";
        szSetting+= get_profile(szSec,"Text11",szInf,"Activation Key:")+"\t"+((szSerial!="")?szSerial:"N/A")+"\r\n";
        szSetting+= get_profile(szSec,"Text12",szInf,"Authentication:")+"\t"+modestr;

        szMsg = "Setup has enough information to start copying the program files.";
        szMsg += "  Please confirm the following settings, especially to see if the authentication is correct.";
        set_text(szSec,"Msg1",szMsg);
        textout(0x0803,17,0x0428,szMsg);
        bEdit = wnd_editbox(0x080c,17,0x082a,0x7804,szSetting);
        szMsg = "If you want to review or change any settings, click [Back].";
        szMsg+= "  If you are satisfied with the settings, click [Next] to begin copying files.";
        set_text(szSec,"Msg2",szMsg);
        textout(16,17,0x0328,szMsg);
#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bNext:
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                wndclose();
                return -1;
              default:
                continue;
            }
        }
}
//      ========================================================
//
//      Check to see if the target directory is okay or what.
//
int     CreateTarget()
{
        char    szDir[128];
        char    szSrc[128], szDst[128];
        int     i;
        if ( (i=CheckPath(szTarget)) < 0 )
                return -2;      // Back to SetTarget
        if ( set_target(szTarget) < 0 ) {       // Impossible error!
                MessageBox("Bad Target: "+szTarget,
                     "Target Directory Setup Error!",MB_OK|MB_ICONINFORMATION);
                return -2;      // Back to SetTarget
        }
        if ( i > 1 ) {  // Target existed
                if ( AskBackup() < 0 )
                        return -2;
        }

        PutProfile();

        nSubDir = eval(get_profile(TARGET,"SubDirectoryNumber",szInf,"0"));
        for(i=0;i<nSubDir;i++) {
                szSubDir[i] = get_profile(TARGET,prints("SubDirectory%d",i+1),szInf);
                szDir = szTarget+"\\"+szSubDir[i];
                if ( !(fexist(szDir,0x10)&0x10) ) {
                        if ( mkdir(szDir) ) {   // Rare case error
                                MessageBox("## Can not create directory: "+szDir,
                                   "Directory Creation Error!",MB_OK|MB_ICONINFORMATION);
                                Terminate(1);
                                return -2;
                        }
                }
        }
//
//      Create Uninstaller (In fact, it is the setup program!)
//
        szSrc = fullname("SETUP.EXE",get_source());
        szDst = fullname("UNINSTAL.EXE",szTarget);
        copyfile(szSrc,szDst);
        szDst = fullname("UNINSTAL.INF",szTarget);
        copyfile(szInf,szDst);
        return 1;       // Important to return 1
}
//      ========================================================
//
//      Check and see if we need to setup a backup directory
//
int     AskBackup()
{
        char    szTitle[80];
        char    szMessage[384];
        char    szFile[128];
        int     i, wid;
        int     bBackup;
        int     nBackup;
        char    szSec[]="AskBackup";

        szFile = fullname(get_profile(SOURCE,"ProductFile",szInf,"TwinCAD.EXE"),szTarget);
        if( !fexist(szFile) )    // Ask backup
                return 0;

        szTitle = get_profile(szSec,"Title",szInf,"Target Directory exist!");
        szMessage = "You have specified an existing directory:";
        szMessage += "\n\n\t%s\n\n";
        szMessage += "and, it has being installed with TwinCAD program files.  ";
        szMessage += "You may choose to create backups on these existing files that will be updated.";

        set_text(szSec,"Msg1",szMessage);
        szMessage = prints(szMessage,szTarget);

        wid = comdlg(szTitle,0);
        textout(0x0807,17,0x0828,szMessage);

        bBackup = wnd_rcbox(9,18,get_profile(szSec,"Text1",szInf," Yes, backup file before overwriting it."),0x4300);
        nBackup = 0;
        wnd_fmark(bBackup,  0,nBackup);

        szMessage = "The Un-install process will restore the previous version, "+
                    "provided that you have chosen to backup these old files.";
        set_text(szSec,"Msg2",szMessage);
        textout(0x080d,17,0x0328,szMessage);

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bBackup:
                nBackup = !nBackup;
                wnd_fmark(bBackup,  0,nBackup);
                continue;
              case bNext:
                if ( nBackup ) {
                    szBackup = szTarget+"\\Backup";
                    if ( !(fexist(szBackup,0x10)&0x10) ) {
                        if (  mkdir(szBackup) ) {
                             MessageBox("## Can not create directory: "+szBackup,
                                "Directory Creation Error!",MB_OK|MB_ICONINFORMATION);
                             Terminate(1);
                             wndclose();
                             return -1;
                        }
                    }
                    set_backup(szBackup);
                }
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                wndclose();
                return -1;
              default:
                continue;
            }
        }
}
//      ========================================================
//
//      Setup program group/folder for TwinCAD
//
#define LB_ADDSTRING        (WM_USER+1)
#define LB_RESETCONTENT     (WM_USER+5)
#define WM_SETREDRAW        0x000B

int     SetPMGroup()
{
        int     i, j;
        int     bFolder, bList;
        int     hwnd, wid;
        int     nPm;
        char    groups[256][64];
        char    szSec[]="SetProgramGroup";
        char    szMsg[256];

        wid = comdlg(get_profile(szSec,"Title",szInf,"Select Program Folder"),0);

        szMsg = "Setup will add program icons to the Program Folder listed below.";
        set_text(szSec,"Msg1",szMsg);
        textout(0x0801,17,0x0228,szMsg);

        szMsg = get_profile(szSec,"Text1",szInf,"&Program Folder:");
        textout(3,17,0x0110,szMsg);
        bFolder = wnd_editbox(0x0404,17,0x0128,0xc080,szFolder);
        szMsg = get_profile(szSec,"Text2",szInf,"E&xisting Folders:");
        textout(0x0806,17,0x0110,szMsg);

        dde_timeout(3000);
        nPm = dde_open("Progman","Progman");
        if ( nPm <= 0 ) {        // Rare case! But, ...
                MessageBox("Can not link to Windows Program Manager!\n"+
                           "You may need to restart Windows to correct this problem.",
                           "Can not create folder!",MB_OK|MB_ICONINFORMATION);
                wndclose();
                return 1;       // Skip
        }

        memset(groups,0,sizeof(groups));
        i = dde_request(nPm,"Groups",groups);   // Asking for group information
        bList = wnd_listbox(0x080c,17,0x062a,0x5083,groups);
                                                // List will be sorted automatically
/*      // Another way to do this, is to add the string one by one...
        // which is slower here, but works the same
        hwnd = wnd_handle(bList);
        SendMessage(hwnd,WM_SETREDRAW,0,0L);    // Disable Redraw during changing
        SendMessage(hwnd,LB_RESETCONTENT,0,0L); // Clear the content
        i = dde_request(nPm,"Groups",groups);   // Asking for group information
        for(j=0;j<i;j++) {
                if ( groups[j]!="" )
                        SendMessage(hwnd,LB_ADDSTRING,0,groups[j]);
        }
        SendMessage(hwnd,WM_SETREDRAW,1,0L);    // Enable Redraw and Update the content
*/
        dde_close(nPm);         // Close the dde channel

        szMsg = "You may type a new folder name, or select one from the Existing Folders list.  Click [Next] to continue.";
        set_text(szSec,"Msg2",szMsg);
        textout(16,17,0x0328,szMsg);
#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bNext:
                szFolder = wnd_settext(bFolder);
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBack:
                wndclose();
                return -1;
              case bList:       // Single click notification
                szFolder = wnd_settext(bList,-1);       // Get current selected
                wnd_settext(bFolder,szFolder);
                continue;
              default:
                continue;
            }
        }
}

int     ConfirmSourceDisk(char idfile[],char label[],int which)
{
        int     i, wid;
        char    szTitle[80];
        char    szBuf[256];
        int     bSource, bOk, bCancel, bBrowse;
        char    szSource[80];
        char    szSec[]="InsertDisk";

        szSource = get_source();
        if ( !set_source(szSource,idfile) )
                return 0;

        szBuf = get_profile(SOURCE,prints("SubDirectoryForDisk%d",which+1),szInf,prints("Disk%d",which+1));
        if ( !set_source(fullname(szBuf,szInitSource),idfile) )
                return 0;
        set_source(szSource);

        szTitle = get_profile(szSec,"Title",szInf,"Insert Disk");
        szBuf = "Please Insert disk #%d, labeled as\n\n%s";
        set_text(szSec,"Msg1",szBuf);

        wid = wndopen(copywnd,szTitle,0xb21e,0x8000);
        szBuf = prints(szBuf,which+1,label);

        wnd_loct(0x800,1);
        wnd_bitmap("BMP_PUTDISK",0x407f,0,0,0xFF00FFL);
        textout(0x0803,8,0x0420,szBuf);

        memset(szBuf,'_',sizeof(szBuf));
        szBuf[40] = 0;
        wnd_loct(7,4);
        wnd_puts(szBuf,0x8600);

        bOk     = wnd_button(9,4,0x108,BTN_ATRB,szOkay);
        bCancel = wnd_button(9,16,0x108,BTN_ATRB,szCancel);
        bBrowse = wnd_button(9,34,0x108,BTN_ATRB,szBrowse);

        wnd_state(bOk,1,0x8080);        // Set default focus

        szBuf = get_profile(szSec,"Text1",szInf,"&Source: ");
        wnd_static(6,1,0x0108,st_atrb|0x200,szBuf);
        bSource = wnd_editbox(6,10,0x0120,0xc080,get_source());

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bSource:
              case bOk:
                szSource = wnd_settext(bSource);
                if ( set_source(szSource,idfile) ) {
                        beep(1);
                        continue;
                }
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              case bBrowse:
                szBuf = getpath(szSource,0,
                        "Please indicate source directory");
                if ( szBuf != "" )
                        szSource = szBuf;
                wnd_settext(bSource,szSource);
                if ( set_source(szSource,idfile) ) {
                        beep(1);
                        continue;
                }
                wndclose();
                return 1;
              default:
                continue;
            }
        }
}
//      ====================================================
//
//      [Disk n]
//      FileNumber = n
//      IDFile =
//      TotalSize =
//      File1 = fname,{{U|C}n}      U -> Unpack, C->Copy
//
int     bText;
int     bMeter;
int     wid;
int     nTrapOver=0;
int     CopyDisk(int which,int first)
{
        char    diskname[10];
        char    szLabel[80];
        int     nFiles;
        char    szIDFile[80];
        char    szFile[80];
        long    lSubTotalByte;
        char    szBuf[256], szType[4];
        int     i, j, key;
        int     whichsub;
        char    szSec[]="CopyFiles";
        char    szUnpack[80];
        char    szCopying[80];
        char    szTo[40];
        char    szAuth1[128],szAuth2[128];
        char    szAuth[128];
        int     nHasAuth;
        int     nAuthDir[36];
        char    szMsg[128];

        diskname = prints("Disk%d",which+1);
        szLabel = get_profile(diskname,"Label",szInf);
        nFiles = eval(get_profile(diskname,"FileNumber",szInf,"0"));
        szIDFile = get_profile(diskname,"IDFile",szInf);
        lSubTotalByte = eval("v1="+get_profile(diskname,"TotalSize",szInf,"0"));
        if ( nFiles <= 0 )
                return 0;       // No files to copy in this disk!
        ConfirmSourceDisk(szIDFile,szLabel,which);

        if ( !nGlobalTotal || !first ) {
                wid = wndopen(copywnd,get_profile(szSec,"Title",szInf,"Copy Files"),0xb21e,0x8000);
                wnd_loct(0x800,1);
                wnd_bitmap("BMP_PUTDISK",0x407f,0,0,0xFF00FFL);
                bText = wnd_static(0x0804,8,0x0524,st_atrb|0x8000,"Copy file");

                wnd_loct(6,4);
                bMeter = wnd_meter(-1,36,0x07e);
                wnd_meter(bMeter,0,0x07e);
                if ( nGlobalTotal )
                        set_total(bMeter,lTotalByte,lCurrentByte);
                else {
                        lCurrentByte=0;
                        set_total(bMeter,lSubTotalByte,lCurrentByte);
                }
                memset(szBuf,'_',sizeof(szBuf));
                szBuf[40] = 0;
                wnd_loct(7,4);
                wnd_puts(szBuf,0x8600);
                bCancel = wnd_button(9,18,0x108,BTN_ATRB,szCancel);
        }

        szUnpack = "Unpacking Archive...\nFrom \t";
        set_text(szSec,"Msg1",szUnpack);
        szCopying = "Copying file...\nFrom \t";
        set_text(szSec,"Msg2",szCopying);
        szTo = "\nTo \t";
        set_text(szSec,"Msg3",szTo);

        szBuf = get_profile(diskname,"AuthFile",szInf);
        memset(nAuthDir,0);
        nHasAuth = 0;
//
//      if ( szBuf != "" && os_type()!=2 ) {    // For KeyCard ReAuthorization
//                              // The NT-Machine is also supported now
        if ( szBuf != "" ) {    // For KeyCard ReAuthorization
                nHasAuth = -1;
                szAuth1 = szAuth2 = "";
                if ( index(szBuf,",") ) // %Ls will be delimited by ':' code!
                     sscanf(szBuf,"%Ls , %s",szAuth1, szAuth2);
                else
                     sscanf(szBuf,"%Ls %s",szAuth1, szAuth2);
                szAuth = fullname(szAuth1,szTarget);
                nAuthDir[0] = 1;        // Searched!
                if ( fexist(szAuth) ) {
                    if ( get_auth(szAuth) >= 0 ) {
                        nHasAuth = 1;
                        printf("\n** Authorization code read from: %s",szAuth);
                    }
                    else
                        nHasAuth = 0;   // No Auth
                }
                else if ( szAuth2!="" && fexist(szAuth2) ) {
                    if ( get_auth(szAuth2) >= 0 ) {
                        nHasAuth = 1;
                        szAuth = szAuth2;
                        printf("\n** Authorization code read from: %s",szAuth);
                    }
                    else
                        nHasAuth = 0;   // No Auth
                }
                szAuth2 = "";   // Reuse this var again
        }

        set_trap("CheckQuit");

        for(i=0;i<nFiles;i++) {
                CheckCancel();
                szBuf = get_profile(diskname,prints("File%d",i+1),szInf);
                whichsub = 0;
                szType = "";
                if ( index(szBuf,",") )
                        sscanf(szBuf,"%Ls , %c %d",szFile,szType,&whichsub);
                else
                        sscanf(szBuf,"%Ls %c %d",szFile,szType,&whichsub);
                szType[1] = 0;
                switch(szType) {
                  case "U": case "u":
                        szBuf = szUnpack;
                        break;
                  case "C": case "c":
                        szBuf = szCopying;
                        break;
                  default:
                        if ( whichsub == 0 )
                                sscanf(szType,"%d",&whichsub);
                        szBuf = szUnpack;
                }
                szIDFile = fullname(szFile,get_source());
                szBuf += szIDFile + szTo;
                if ( whichsub < 0 ) {   // Special Directory
                    set_subpath();
                    switch(whichsub) {
                      case -1:          // Windows Directory
                        set_target(get_syspath(1));
                        break;
                      case -2:          // System Directory
                        set_target(get_syspath(2));
                        break;
                      default:
                        set_target(szTarget);
                        break;
                    }
                }
                else {
                    szBuf += szTarget;
                    if ( whichsub && (whichsub <= nSubDir) ) {
                        szBuf += "\\"+szSubDir[whichsub-1];
                        set_subpath(szSubDir[whichsub-1]);
                        if ( (nHasAuth==-1) && (nAuthDir[whichsub]==0)) {
                            szAuth = fullname(szAuth1,get_target());
                            if ( fexist(szAuth) ) {
                                if ( get_auth(szAuth) >= 0 )
                                    nHasAuth = 1;
                                else
                                    nHasAuth = 0;   // No Auth
                            }
                            nAuthDir[whichsub] = 1;
                        }
                    }
                    else {
                        set_subpath();
                    }
                }
                wnd_settext(bText,szBuf);
#ifdef  NEEDREDRAW
                redraw(wid);
#endif
                CheckCancel();
                if ( !fexist(szIDFile) ) {  // Should not happen!
                     j = MessageBox("Missing File: "+szIDFile,
                       "Can not find file error!",MB_OKCANCEL|MB_ICONINFORMATION);
                     if ( j == IDCANCEL )
                        Terminate(1);
                }
                switch(szType) {
                  case "C": case "c":
                        lCurrentByte += copytarget(szFile);
                        break;
                  default:
                        lCurrentByte += unpack(szFile);
                        break;
                }
                if ( whichsub < 0 )     // Restore back target directory
                        set_target(szTarget);
                else if ( nHasAuth && szAuth2=="" ) {  //
                        szBuf = fullname(szAuth1,get_target());
                        if ( fexist(szBuf) )
                                szAuth2 = szBuf;       // Found!!
                }
        }
        if ( nHasAuth == 1 ) {  // get_auth is OK!
            szBuf = "KeyCard Authentication Error!";
            if ( szAuth2 != "" ) {      // Target file is found!
                i = set_auth(szAuth2);
                if ( i < 0 ) {  // Rare case!
                    MessageBox(prints("## Error Code %d on file:\n\n%s\n\nBy File: %s",i,szAuth2,szAuth),
                        szBuf,MB_OK|MB_ICONEXCLAMATION);
                }
                else
                    printf("\n** Successfully Authorize file: %s",szAuth2);
            }
            else {      // Nothing to Authorized!
                if ( $debug() ) {
                    MessageBox("## Can not find "+szAuth1+"to set_auth()",
                        szBuf,MB_OK|MB_ICONEXCLAMATION);
                }
            }
        }

        if ( !nGlobalTotal )
                wndclose();
        return 0;
}
//
//      This routine is called via internal trapping
//
int     CheckQuit(int key)
{
        switch(key) {
          case bCancel:
          case -1:
                return nTrapOver |= askquit();
        }
        return 0;
}
//
int     CheckCancel()
{
        int     key, i;

        if ( nTrapOver || trap_key() )
             Terminate(-1);
/*
        key = wnd_gbtn(0x0c00);
        switch(key) {
          case nBtn:
          case -1:
          case 0:
                Terminate(1);
        }
*/
}
//      ========================================================
//
//      Installation completed, doing some option jobs here
//
int     Completed()
{
        char    szTitle[80];
        char    szMessage[256];
        char    szOver[128];
        char    szBuf[256];
        int     i, j, wid;
        int     nOptions;
        int     bOpt[10];
        int     nOpt[10];
        int     rInc;
        int     rBase;

        char    szSec[]="SetupCompleted";

        szMessage = "Setup has finished installing TwinCAD on your computer.";
        szMessage += "\n\nSetup can launch the Read Me file and TwinCAD.  Choose the options you want below.";
        szOver = "Click Finish to complete Setup.";
        szTitle = get_profile(szSec,"Title",szInf,"Setup Complete");
        set_text(szSec,"Msg1",szMessage);
        set_text(szSec,"Msg2",szOver);

        nOptions = eval(get_profile(szSec,"OptionNumber",szInf,"0"));
        memset(nOpt,0,sizeof(nOpt));
        memset(bOpt,0,sizeof(nOpt));

        wid = comdlg(szTitle,1);
        textout(0x0804,17,0x0528,szMessage);
        rInc = 0x0801;
        if ( nOptions <= 3 )
            rBase = 0x0806;
        else
            rBase = 0x0006;
        for(i=0;i<nOptions;i++) {
            szBuf = get_profile(szSec,prints("Option%d",i+1),szInf,"Yes, this is an option!");
            bOpt[i] = wnd_rcbox(rBase+rInc*i,18,szBuf,0x4300);
            wnd_fmark(bOpt[i],  0,nOpt[i]);
            if ( i == 0 )
                wnd_style(bOpt[0],WS_GROUP,1);
        }
        j = rBase+rInc*i+1;
        if ( nOptions <= 4 )
                j = 0x080d;
        if ( nOptions <= 6 )
                textout(j,17,0x0228,szOver);

#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case 0:
              case -1:
              case bCancel:
              case bNext:
                wndclose();
                break;
              default:
                for(j=0;j<nOptions;j++) {
                    if ( bOpt[j] != i ) continue;
                    nOpt[j] = !nOpt[j];
                    wnd_fmark(bOpt[j],  0,nOpt[j]);
                    break;
                }
                continue;
            }
            break;
        }
        // Need to convert all '\' into double '\' for string reevalation
        szOver = strrplx(szTarget,"\\","\\\\");

        for(i=0;i<nOptions;i++) {
            if ( nOpt[i] == 0 ) continue;
            szBuf = get_profile(szSec,prints("Action%d",i+1),szInf,"");
            if ( szBuf == "" ) continue;
            szBuf = strrplx(szBuf,"%-1+",get_syspath(1)+"\\\\");
            szBuf = strrplx(szBuf,"%-2+",get_syspath(2)+"\\\\");
            szBuf = strrplx(szBuf,"%0+",szOver+"\\\\");
            szBuf = strrplx(szBuf,"%-1",get_syspath(1));
            szBuf = strrplx(szBuf,"%-2",get_syspath(2));
            szBuf = strrplx(szBuf,"%0",szOver);
            for(j=0;j<nSubDir;j++) {
                    if ( !index(szBuf,"%") )
                            break;
                    szBuf = strrplx(szBuf,"%"+prints("%d+",j+1),
                                     szOver+"\\\\"+szSubDir[j]+"\\\\");
                    szBuf = strrplx(szBuf,"%"+prints("%d",j+1),
                                     szOver+"\\\\"+szSubDir[j]);
            }
            if ( $debug() )
                    printf("\nOption%d-> Eval('%s')",i+1,szBuf);
            eval(szBuf);
        }
        return 1;
}
//
//      Select Language
//
int     nUseLocal = 1;
int     nFirstTime=1;
int     SetLanguage()
{
        char    szLocal[40];
        char    szMsg[256];
        char    szBuf[256];
        char    szTitle[80];
        int     bStd, bLocal;
        int     i, wid;
        char    szSec[]="SetLanguage";

        nLid = os_language();
//      SetupInf();

        if ( nFirstTime ) {
            szMsg = "TCAM Product Installation";
            set_text(szSec,"Text1",szMsg);
            wnd_settext(wnd_handle(),szMsg);
            szMsg = "Installation Log";
            set_text(szSec,"Text2",szMsg);
            wid = FindWindow("TextBox");
            if ( wid )
                wnd_settext(wid,szMsg);
            nFirstTime = 0;
        }

        szMsg = "According to your version of Windows, you may choose to use one of the following languages for the Setup.\n\n";
        szBuf = "";
        switch(nLid){  // Our license agreement
          case BIG5:
                szBuf = "̵tΪy䴩, bw˹L{, ziHܨϥΤUCy:";
                szLocal = " Traditional &Chinese c餤";    break;
          case SJIS:
                szLocal = " &Japanese";   break;
          case GB2312:
                szBuf = "Ӵϵͳ԰汾֧Ԯ, ڰװ, ѡʹе:";
                szLocal = " Simplified &Chinese ";    break;
          case KOREAN:
                szLocal = " &Korean";     break;
          default:
                return 1;       // Don't care, Use English!
        }

        szTitle = get_profile(szSec,"Title",szInf,"Select Your Language");
        wid = comdlg(szTitle,-1);

        set_text(szSec,"Msg1",szBuf);
        szMsg+= szBuf;
        textout(0x0807,17,0x0828,szMsg);
        bStd = wnd_rcbox(7,18," &English",0xc300);
        bLocal = wnd_rcbox(0x0808,18,szLocal,0xc300);

        szMsg = "In software, you may issue SWITCH command to switch between these two languages.";
        set_text(szSec,"Msg2",szMsg);
        textout(0x080d,17,0x0428,szMsg);

        wnd_loct(0x080e,50);
        wnd_bitmap("BMP_TCAMMARK",0x407f,0,0,0xFFFFFFL);

        wnd_fmark(bStd,    1,!nUseLocal);
        wnd_fmark(bLocal,  1,nUseLocal);

#ifdef  NEEDREDRAW
        redraw(wid);    // For 3D text to appear
#endif
        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case bStd:
                if ( !nUseLocal ) continue;
                nUseLocal = 0;
                wnd_fmark(bStd,    1,!nUseLocal);
                wnd_fmark(bLocal,  1,nUseLocal);
                // Because of Transparent attribute, we need to refresh
                // the background in Win 3.1 !
                if ( os_type() < 1)  redraw(wid);
                continue;
              case bLocal:
                if ( nUseLocal ) continue;
                nUseLocal = 1;
                wnd_fmark(bStd,    1,!nUseLocal);
                wnd_fmark(bLocal,  1,nUseLocal);
                if ( os_type() < 1)  redraw(wid);
                continue;
              case bNext:
                if ( !nUseLocal )
                        nLid = 0;
                wndclose();
                return 1;
              case 0:
              case -1:
              case bCancel:
                Terminate(1);
                continue;
              default:
                continue;
            }
        }
}

int     nChecked=0;
int     ChkInstall()
{
        int     nMajor, nMinor, nStep;
        int     nDif;
        char    szTitle[80];
        char    szMsg[384];
        char    szMsg1[128];
        char    szTemp[40];
        char    szSec[]="AlreadyInstalled";
        int     i;

        if ( !nInstalled || nChecked )
                return 1;

        nChecked = 1;
        szTitle = "TwinCAD had already been installed!";
        szTitle = get_profile(szSec,"Title",szInf,szTitle);

        szTemp = get_profile(szPID,"ProductVersion",WinINI,"0.0.0");
        sscanf(szTemp,"%d.%d.%d",&nMajor,&nMinor,&nStep);

        nDif = 0;
        if ( nMajor < nVMajor ) nDif = -1;
        if ( nMajor > nVMajor ) nDir = 1;
        if ( nDif == 0 ) {
                if ( nMinor < nVMinor ) nDif = -1;
                if ( nMinor > nVMinor ) nDif = 1;
        }
        if ( nDif == 0 ) {
                if ( nStep < nVStep ) nDif = -1;
                if ( nStep > nVStep ) nDif = 1;
        }
        szMsg = "A version of TwinCAD [V%s] had been installed previously in the directory:\n\n%s";
        set_text(szSec,"Msg1",szMsg);
        szMsg = prints(szMsg,szTemp,get_profile(szPID,"InstallPath",WinINI));
        switch(nDif) {
          case -1:
                szMsg1 = "which is older than this one to install.";
                set_text(szSec,"Msg2",szMsg1);
                break;
          case 1:
                szMsg1 = "which is newer than this one to install.";
                set_text(szSec,"Msg3",szMsg1);
                break;
          case 0:
                szMsg1 = "which is the same as this one to install.";
                set_text(szSec,"Msg4",szMsg1);
                break;
        }
        szMsg += "\n\n"+szMsg1+"\n\n";
        szMsg1 = "Do you want to go on with this setup program?";
        set_text(szSec,"Msg5",szMsg1);
        szMsg += szMsg1;

        for(;;) {
                i = MessageBox(szMsg,szTitle,MB_YESNO|MB_ICONEXCLAMATION);
                switch(i) {
                  case IDYES:   return 1;
                  case IDNO:
                  case IDCANCEL:
                        Terminate(1);
                        continue;
                }
        }
}

int     aborted()
{
        char    szMsg[384];
        char    szBat[128];
        char    szTitle[80];
        char    szOver[128];
        char    szBuf[256];
        int     i, j, wid;
        int     rInc;
        int     rBase;
        int     bUndo, bBatch, bNothing;
        int     nWhich;

        char    szSec[]="SetupAborted";

        printf("\n\n** Intallation process is not complete...");
        printf(  "\n   Aborted upon user request!");
        set_target(szTarget);
        set_subpath();
        save_log("install.log");

        szMsg = "Setup is about to exit without completing the installation.\n\n ";
        szMsg+= "Setup can undo what have been done during the installation process. ";
        szMsg+= "However, it's up to you.";

        szOver = "Click [Finish] to terminate Setup.";
        szTitle = get_profile(szSec,"Title",szInf,"Setup Aborted");
        set_text(szSec,"Msg1",szMsg);
        set_text(szSec,"Msg2",szOver);

        wid = comdlg(szTitle,1);
        textout(0x0805,17,0x0628,szMsg);
        rInc = 0x0801;
        rBase = 0x0807;

        szBuf = get_profile(szSec,"Text1",szInf," Undo it now!");
        bUndo = wnd_rcbox(rBase+rInc*0,18,szBuf,0xc300);
        szBuf = get_profile(szSec,"Text2",szInf," Just create a DOS batch file for me.");
        bBatch= wnd_rcbox(rBase+rInc*1,18,szBuf,0xc300);
        szBuf = get_profile(szSec,"Text3",szInf," Do nothing.");
        bNothing = wnd_rcbox(rBase+rInc*2,18,szBuf,0xc300);
        wnd_style(bUndo,WS_GROUP,1);
        textout(0x080d,17,0x0228,szOver);

        nWhich = 0;
        wnd_fmark(bUndo,   1, nWhich==0);
        wnd_fmark(bBatch,  1, nWhich==1);
        wnd_fmark(bNothing,1, nWhich==2);

        for(;;) {
            i = wnd_gbtn(GBTNFLAG);
            switch(i) {
              case 0:
              case -1:
              case bCancel:
              case bNext:
                wndclose();
                break;
              case bUndo:
                if ( nWhich == 0 ) continue;
                nWhich = 0;
                wnd_fmark(bUndo,   1, nWhich==0);
                wnd_fmark(bBatch,  1, nWhich==1);
                wnd_fmark(bNothing,1, nWhich==2);
                continue;
              case bBatch:
                if ( nWhich == 1 ) continue;
                nWhich = 1;
                wnd_fmark(bUndo,   1, nWhich==0);
                wnd_fmark(bBatch,  1, nWhich==1);
                wnd_fmark(bNothing,1, nWhich==2);
                continue;
              case bNothing:
                if ( nWhich == 2 ) continue;
                nWhich = 2;
                wnd_fmark(bUndo,   1, nWhich==0);
                wnd_fmark(bBatch,  1, nWhich==1);
                wnd_fmark(bNothing,1, nWhich==2);
                continue;
            }
            break;
        }
        switch(nWhich) {
          case 0:
            szBat = fullname("UNINST.TCL",get_syspath(3));
            SaveUndoList(szBat,1);
            run(szBat);
//          remove(szBat);      // No need!
            break;
          case 1:
            szBat = fullname("UNINST.BAT",szTarget);
            SaveUndoList(szBat,0);
            printf("\nUndo batch file created: %s\n",szBat);
          default:
            winexec("Notepad.exe "+szTarget+"\\install.log",1);
            break;
        }
        return 1;
}

#define MAXWIDTH  60
#define MINWIDTH  15

int     MsgBox(char Msg[], char szTitle[], int nType)
{
        int     wnd[]={0,14,0,50,0xb77f};
        int     i, wid, idx;
        int     atrb, atrbz, atrby;
        int     nLine, nChar;
        char    szMsg[512], szIcon[20];
        int     bBtnID[3];
        int     bBtn1, bBtn2, bBtn3;
        int     rBase, cBase, nBtn;

        atrb = st_atrb;  atrbz = st_atrbz;   atrby = st_atrby;
        st_atrb = 0x0000; st_atrbz = 0x00ff; st_atrby = 0x40f0;

        szMsg = Msg;
        nLine = nChar = 0;
        idx = 0;
        while(i=index(&szMsg[idx],"\n")) {
                nLine++;
                if ( i > nChar ) nChar = i;
                if ( i > MAXWIDTH ) nLine += i/MAXWIDTH;
                idx += i;
        }
        nLine++;
        i = len(&szMsg[idx]);
        if ( i > nChar ) nChar = i;
        if ( i > MAXWIDTH ) nLine += i/MAXWIDTH;
        if ( nChar > MAXWIDTH ) nChar = MAXWIDTH;
        if ( nChar < MINWIDTH ) nChar = MINWIDTH;
        if ( nLine <= 3 ) nLine = 3;

        wnd[1] = nLine + 5;
        wnd[3] = nChar + 8;

        szIcon = "";
        switch(nType&MB_ICONMASK) {
          case MB_ICONHAND:     szIcon = IDI_HAND;      break;
          case MB_ICONQUESTION: szIcon = IDI_QUESTION;  break;
          case MB_ICONEXCLAMATION: szIcon = IDI_EXCLAMATION;    break;
          case MB_ICONASTERISK: szIcon = IDI_ASTERISK;  break;
        }
        if ( szIcon != "" ) wnd[3] += 8;

        wid = wndopen(wnd,szTitle,0xb21e,0x8000);

        if ( szIcon != "" ) {
            wnd_loct(0x801,3);
            wnd_bitmap(szIcon,0x407f,0,0,0xFFFFFFL);
            textout(0x0800+nLine,12,nChar|(nLine<<8),szMsg);
        }
        else
            textout(0x0800+nLine,4,nChar|(nLine<<8),szMsg);

        rBase = 0x0802+nLine;
        cBase = wnd[3]/2;
        bBtn1 = bBtn2 = bBtn3 = 0;

        switch(nType&MB_TYPEMASK) {
          case MB_OK:   nBtn = 1;
                bBtn1 = wnd_button(rBase,cBase-4,0x108,BTN_ATRB,szOkay);
                bBtnID[0] = IDOK;
                break;
          case MB_YESNOCANCEL:  nBtn = 3;
                bBtn1 = wnd_button(rBase,cBase-16,0x108,BTN_ATRB,szYes);
                bBtnID[0] = IDYES;
                bBtn2 = wnd_button(rBase,cBase-4,0x108,BTN_ATRB,szNo);
                bBtnID[1] = IDNO;
                bBtn3 = wnd_button(rBase,cBase+8,0x108,BTN_ATRB,szCancel);
                bBtnID[2] = IDCANCEL;
                break;
          case MB_YESNO:        nBtn = 2;
                bBtn1 = wnd_button(rBase,cBase-10,0x108,BTN_ATRB,szYes);
                bBtnID[0] = IDYES;
                bBtn2 = wnd_button(rBase,cBase+2,0x108,BTN_ATRB,szNo);
                bBtnID[1] = IDNO;
                break;
          case MB_OKCANCEL:     nBtn = 2;
          default:              nBtn = 2;
                bBtn1 = wnd_button(rBase,cBase-10,0x108,BTN_ATRB,szOkay);
                bBtnID[0] = IDOK;
                bBtn2 = wnd_button(rBase,cBase+2,0x108,BTN_ATRB,szCancel);
                bBtnID[1] = IDCANCEL;
                break;
        }
#ifdef  NEEDREDRAW
        redraw(wid);
#endif
        st_atrb = atrb;  st_atrbz = atrbz;  st_atrby = atrby;
        for(;;) {
            i = wnd_gbtn(0xf000);       // Application Modal
            switch(i) {
              case 0:
              case -1:
                wndclose();
                return bBtnID[nBtn-1];
              case bBtn1:
                wndclose();
                return bBtnID[0];
              case bBtn2:
                wndclose();
                return bBtnID[1];
              case bBtn3:
                wndclose();
                return bBtnID[2];
            }
        }
}

#ifndef TPInstall
//
// Define some stub functions if not in TPInstall, since this program is
//    also used to test some new TCL functions in TwinCAD.
// With these stub functions, you may run INSTALL.TCL in TwinCAD.
//
char    szLocalSource[80]= takepath(get_syspath(-1));
get_source(){   return szLocalSource; }
set_source(){   return 0;       }
set_target(){   return 1;       }
get_target(){   return szTarget;}
set_subpath(){  return 1;       }
save_log(){     return 1;       }
CheckSerial(){  return "";      }
TCADLevel(){    return 0;       }
set_auth(){     return 0;       }
get_auth(){     return 0;       }
unpack(){       return 0;       }
copytarget(){   return 0;       }
set_backup(){   return 0;       }
set_total(){    return 0;       }
set_trap(){     return 0;       }
trap_key(){     return 0;       }
SaveUndoList(){ return 0;       }
LayBackGround()
{
        int     wnd[6]={0,24,0,70,0x89f,0x32f0};
        return wndopen(wnd,"TCAM Product Installation, TestDrive!",0x309f,0x4000);
}
int     wBackGround=LayBackGround();
#endif
