//	==============================================================
//
//	TwinCAD V3.1 Un-Installation Program
//
//	Developed by Kang, Hsin-Min.
//	Copyright (c) 1997, TCAM Development House, Co. Ltd.
//
//	This program is written in TCL (TwinCAD Command Language)
//	and must be executed by the TPInstall(tm) executable, which
//	must be renamed to UNINSTALL.EXE
//
//	TPInstall(tm) is also developed by Kang, Hsin-Min, and is a
//	copyrighted product of TCAM Development House.
//
//#define DEBUG   1
#define MYVERSION	"TP1.0.1 (Nov 12, 1997)"
#define TARGET	"Target"
#define SOURCE	"Source"
#define PMITEM	"ProgmanCommand"
#define GENERAL "General Setup"
#define WinINI	""
#define STDKEY	0x2215
#define NETKEY	0x1580

#define BOOL	int
#define TRUE	1
#define FALSE	0
#define EOF	-1

#define BIG5		0x404
#define GB2312		0x804
#define SJIS		0x411
#define KOREAN		0x412
#define ASCII		0x409

/* Clipboard command messages */
#define WM_CUT		    0x0300
#define WM_COPY 	    0x0301
#define WM_PASTE	    0x0302
#define WM_CLEAR	    0x0303
#define WM_UNDO 	    0x0304

#define MB_OK		    0x0000
#define MB_OKCANCEL	    0x0001
#define MB_ABORTRETRYIGNORE 0x0002
#define MB_YESNOCANCEL	    0x0003
#define MB_YESNO	    0x0004
#define MB_RETRYCANCEL	    0x0005
#define MB_TYPEMASK	    0x000F

#define MB_ICONHAND	    0x0010
#define MB_ICONQUESTION     0x0020
#define MB_ICONEXCLAMATION  0x0030
#define MB_ICONASTERISK     0x0040
#define MB_ICONMASK	    0x00F0

#define MB_ICONINFORMATION  MB_ICONASTERISK
#define MB_ICONSTOP	    MB_ICONHAND

#define MAKEINTRESOURCE(n)  "#n"

/* Standard icon resource IDs from Windows */
#define IDI_APPLICATION     MAKEINTRESOURCE(32512)
#define IDI_HAND	    MAKEINTRESOURCE(32513)
#define IDI_QUESTION	    MAKEINTRESOURCE(32514)
#define IDI_EXCLAMATION     MAKEINTRESOURCE(32515)
#define IDI_ASTERISK	    MAKEINTRESOURCE(32516)

/* Standard dialog button IDs */
#define IDOK		    1
#define IDCANCEL	    2
#define IDABORT 	    3
#define IDRETRY 	    4
#define IDIGNORE	    5
#define IDYES		    6
#define IDNO		    7

#define MessageBox MsgBox

/* Useful Device Parameters for DeviceCaps() */
#define HORZSIZE      4
#define VERTSIZE      6
#define HORZRES       8
#define VERTRES       10
#define BITSPIXEL     12
#define PLANES	      14
#define NUMCOLORS     24
#define ASPECTX       40
#define ASPECTY       42
#define ASPECTXY      44

#define LOGPIXELSX    88
#define LOGPIXELSY    90

#define SIZEPALETTE  104
#define NUMRESERVED  106
#define COLORRES     108

/* Control window styles */
#define WS_GROUP	    0x00020000L
#define WS_TABSTOP	    0x00010000L

#define GBTNFLAG	0xf800
#define BTN_ATRB	0x1277
#define ST_ATRBZ	0x0088
#define ST_ATRB 	0x00ff
#define DLG_ATRB	0x3fef

#define ST_GRAYZ	0x00ff
#define ST_GRAY 	0x0000
#define DLG_GRAY	0x3770

#define WM_CLOSE	0x0010

int	nColorDepth=DeviceCaps(0,BITSPIXEL);	// System Color Depth

int	st_atrbz={(nColorDepth>=15)?ST_ATRBZ:ST_GRAYZ};
int	st_atrb={(nColorDepth>=15)?ST_ATRB:ST_GRAY};
int	dlg_atrb={(nColorDepth>=15)?DLG_ATRB:DLG_GRAY};
int	dlgwnd[]={0,21,0,60,dlg_atrb};
//
char	szSec[]="Uninstall";
char	szInf[80]="UNINSTAL.INF";
char	szFolder[80]="TwinCAD V3.1";
int	nLid=os_language();
char	szPID[60]="TwinCAD";
char	szPINI[60]="TwinCAD.INI";
char	szPName[60]="TwinCAD V3.1";
char	szLogFile[60]="INSTALL.LOG";
char	szVersion[60]="";
char	szLVersion[60]="";
char	szDate[60]="";
char	szLDate[60]="";
int	nItems;
char	szItems[40][80];
char	szPgms[40][60];
//
//	Define useful macro
//
#define textout(r,c,s,t) {wnd_static((r)|0x100,(c)|0x100,s,st_atrbz,t);wnd_static(r,c,s,st_atrb,t);}
#define set_text(s,i,v) {v=get_profile(s,i,szInf,v); if (index(v,"\""))v=eval(v); else v=eval("\""+v+"\"");}
//
char	szOkay[20]="&Ok";
char	szCancel[20]="&Cancel";
char	szBack[20]="< &Back";
char	szNext[20]="> &Next";
char	szFinish[20]="&Finish";
char	szYes[20] = "&Yes";
char	szNo[20] = "&No";
char	szBrowse[20]="B&rowse";
char	szResume[20]="&Resume";
char	szExit[20]="E&xit";

int	main()
{
	int	i;
	char	szMsg[256];
#ifdef	DEBUG
	$debug(1);
#endif
	userbrk(0);		// Disable user break

	SendMessage(FindWindow("TextBox",""),WM_CLOSE,0,0L);

	StartUp();
#ifndef TPInstall
	szMsg = "Can not execute this TCL program from TwinCAD.\n"+
		"To un-install TwinCAD of the last installation,\n"+
		"Run UNINSTAL.EXE to execute this program.";
	set_text(szSec,"Msg1",szMsg);
	MessageBox(szMsg,"Need TPInstall!",MB_OK|MB_ICONSTOP);
	exit(1);
#endif
	if ( ChkLogFile() ) exit(1);
	if ( ChkTwinCAD() ) exit(1);

	UnInstall();

	exit(0);
}


ChkTwinCAD()
{
	int	nDde;
	char	szStatus[20];
	char	szMsg[384];
	int	nCount, i;

	nDde = dde_open("TwinCAD","System");
	if ( nDde <= 0 )
		return 0;	// TwinCAD is not active, so
				// it would be safe to un-install TwinCAD
	dde_close(nDde);

	szMsg = "At least a copy of TwinCAD is now running in the system!\n";
	szMsg+= "You have to close it first to un-install it.\n\n";
	szMsg+= "Do you want me to close it and proceed the uninstallation? ";

	set_text(szSec,"Msg2",szMsg);
	i = MessageBox(szMsg,
		   "Can't un-install yet!",MB_OKCANCEL|MB_ICONEXCLAMATION);

	if ( i != IDOK ) {
		return 1;
	}

	for(;;) {
		nDde = dde_open("TwinCAD","System");
		if ( nDde <= 0 )
			break;
		do {	// Probe to see if the server is opened now
		     delay(200);
		     dde_request(nDde,"Status",szStatus);
		} while (szStatus!="Ready" && szStatus!="Down" && (++nCount<25));
		if ( szStatus!="Ready" && szStatus!="Down" ) {
			szMsg = "Can not close TwinCAD.\n\n"+
				"Un-Installation process aborted.";
			set_text(szSec,"Msg3",szMsg);
			MessageBox(szMsg,
				   "TwinCAD is busy.",MB_OK|MB_ICONSTOP);
			return 1;
		}
		dde_execute(nDde,"^C^CQUIT Y ");
		dde_close(nDde);
		delay(1000);	// Give 1 second for TwinCAD to leave

	}
	// Okay, everything is clear

	return 0;
}

int	ChkLogFile()
{
	char	szMsg[256];
	szLogFile = fullname("INSTALL.LOG",get_syspath(0));
	if ( fexist(szLogFile) ) return 0;
	szMsg = "Can not open installation log:\n\n%s\n\n"+
		"Unable to proceed un-installation now." ;
	set_text(szSec,"Msg4",szMsg);
	MessageBox(prints(szMsg,szLogFile),
		"Missing original installation log",MB_OK|MB_ICONSTOP);
	return 1;
}

UnInstall()
{
	char	szBat[128];
	int	wnd[5]={0,18,0,60,0x3770};
	char	szMsg[384], szBuf[256];
	int	i, hasprofile;
	int	hdl;

	szBat = fullname("UNINST.TCL",get_syspath(3));
	switch(SaveUndoList(szBat,1,szLogFile)) {
	  case 0:	// not possible error
	    MessageBox("Can not create temporary working file.",
		       "Bad Windows Temporary drive!",MB_ICONSTOP|MB_OK);
		return 1;
	  case 1:	// Nothing to undo!
	    szMsg = "Installation log does not contain any operation needed to be recovered.";
	    set_text(szSec,"Msg5",szMsg);
	    MessageBox(szMsg,
		       "Nothing to do!",MB_ICONSTOP|MB_OK);
		return 1;
	}

	GetLastProfile();

	szMsg = "You are going to un-install %s [%s], which was installed at %s";
	set_text(szSec,"Msg6",szMsg);
	szMsg = prints(szMsg,szPName,szVersion,szDate);
	if ( szLVersion != "" ) {
	    szBuf = "The un-installation will restore its previous version [%s], installed at %s";
	    set_text(szSec,"Msg7",szBuf);
	    szBuf = prints(szBuf,szLVersion,szLDate);
	    szMsg += "\n\n"+szBuf;
	}

	szBuf = "Are you sure you want to do this? ";
	set_text(szSec,"Msg8",szBuf);
	szMsg += "\n\n"+szBuf;

	i = MessageBox(szMsg,"Uninstallation Confirmation",MB_OKCANCEL|MB_ICONEXCLAMATION);
	if ( i != IDOK ) {
		remove(szBat);
		return 1;
	}

	run(szBat);
	remove(szBat);

	pm_command("[ShowGroup("+szFolder+",2)]");
	pm_command("[ShowGroup("+szFolder+",1)]");
	for(i=0;i<nItems;i++) {
		if ( fexist(szPgms[i]) )
			continue;
		pm_command("[DeleteItem("+szItems[i]+")]");
	}
	nItems = pm_request(szFolder,szItems);
	if ( nItems ) { 		// Check and Remove the trailing null items
	    for(;nItems>0;nItems--)	//   to avoid a possible old bug.
		if ( szItems[nItems-1] != "" ) break;
	}
	if ( nItems <= 1 )	// No more items in the group
		pm_command("[DeleteGroup("+szFolder+")]");
	put_profile(szPID,"InstallDate",szLDate,WinINI);
	put_profile(szPID,"ProductVersion",szLVersion,WinINI);

	return 1;
}

int	GetLastProfile()
{
	int	hdl;
	int	idx;
	char	szBuf[256], keystr[80];
	char	szPgm[80], szParm[80];

	hdl = fopen(szLogFile,"r");
	if ( fstrloct(hdl,"== Installation Profile ==") ) {
	    fgets(szBuf,255,hdl);
	    while(fgets(szBuf,255,hdl)>=0) {
		if ( szBuf[1] == '=' ) break;
		idx = index(szBuf,":");
		if ( idx == 0 ) continue;
		keystr = left$(szBuf,idx);
		szBuf -= keystr;
		if ( szBuf[0] == ' ' )
			szBuf -= " ";
		switch(keystr) {
		  case " ........Product ID:":  szPID = szBuf;  continue;
		  case " ......Product Name:":  szPName = szBuf; continue;
		  case " ....ProductVersion:":  szVersion = szBuf; continue;
		  case " .Installation Date:":  szDate = szBuf; continue;
		  case " ..LastInstallation:":  szLDate = szBuf; continue;
		  case " LastProductVersion:":  szLVersion = szBuf; continue;
		}
	    }
	}
	if ( !fstrloct(hdl,"CreateGroup:") ) {
		fclose(hdl);
		return 0;
	}
	fgets(szBuf,255,hdl);
	szFolder = szBuf - "CreateGroup: ";
	nItems = 0;
	while(fgets(szBuf,255,hdl)>=0) {
	    if ( !index(szBuf,"pm_command:") ) break;
	    if ( !index(szBuf,"AddItem") ) continue;
	    szBuf -= "pm_command: [AddItem(";
	    idx = index(szBuf,",");
	    szParm = "";
	    sscanf(left$(szBuf,idx-1)," %s %s",szPgm,szParm);
	    szBuf -= left$(szBuf,idx-1);
	    szBuf -= ",";
	    szBuf -= " ";
	    idx = index(szBuf,",");
	    if ( idx ) szBuf = left$(szBuf,idx-1);
	    idx = index(szBuf,")");
	    if ( idx ) szBuf = left$(szBuf,idx-1);
	    if ( !index(szPgm,":") )    // No full path name!
		szPgm = szParm;
	    if ( szPgm == "" )  continue;
	    szPgms[nItems] = szPgm;
	    szItems[nItems] = szBuf;
	    nItems++;
	}
	fclose(hdl);
	return 1;
}

int	StartUp()
{
	char	szTemp[80];
	char	szButtons[]="Buttons";

	szInf = fullname("UNINSTAL.INF",get_source());
	szPID = get_profile(SOURCE,"ProductID",szInf,szPID);
	szPINI = get_profile(SOURCE,"ProductProfile",szInf,szPID+".INI");
	szPName= get_profile(SOURCE,"ProductName",szInf,szPName);
	szVersion = get_profile(SOURCE,"ProductVersion",szInf);

	// Get Common button text
	set_text(szButtons,"ok",szOkay);
	set_text(szButtons,"Cancel",szCancel);
	set_text(szButtons,"Back",szBack);
	set_text(szButtons,"Next",szNext);
	set_text(szButtons,"Finish",szFinish);
	set_text(szButtons,"yes",szYes);
	set_text(szButtons,"No",szNo);
	set_text(szButtons,"Browse",szBrowse);
	set_text(szButtons,"Resume",szResume);
	set_text(szButtons,"Exit",szExit);
	return 1;
}

#define MAXWIDTH  60
#define MINWIDTH  15

int	MsgBox(char Msg[], char szTitle[], int nType)
{
	int	wnd[]={0,14,0,50,0xb77f};
	int	i, wid, idx;
	int	atrb, atrbz;
	int	nLine, nChar;
	char	szMsg[512], szIcon[20];
	int	bBtnID[3];
	int	bBtn1, bBtn2, bBtn3;
	int	rBase, cBase, nBtn;

	atrb = st_atrb;  atrbz = st_atrbz;
	st_atrb = 0x0000; st_atrbz = 0x00ff;

	szMsg = Msg;
	nLine = nChar = 0;
	idx = 0;
	while(i=index(&szMsg[idx],"\n")) {
		nLine++;
		if ( i > nChar ) nChar = i;
		if ( i > MAXWIDTH ) nLine += i/MAXWIDTH;
		idx += i;
	}
	nLine++;
	i = len(&szMsg[idx]);
	if ( i > nChar ) nChar = i;
	if ( i > MAXWIDTH ) nLine += i/MAXWIDTH;
	if ( nChar > MAXWIDTH ) nChar = MAXWIDTH;
	if ( nChar < MINWIDTH ) nChar = MINWIDTH;
	if ( nLine <= 3 ) nLine = 3;

	wnd[1] = nLine + 5;
	wnd[3] = nChar + 8;

	szIcon = "";
	switch(nType&MB_ICONMASK) {
	  case MB_ICONHAND:	szIcon = IDI_HAND;	break;
	  case MB_ICONQUESTION: szIcon = IDI_QUESTION;	break;
	  case MB_ICONEXCLAMATION: szIcon = IDI_EXCLAMATION;	break;
	  case MB_ICONASTERISK: szIcon = IDI_ASTERISK;	break;
	}
	if ( szIcon != "" ) wnd[3] += 8;

	wid = wndopen(wnd,szTitle,0xb21e,0x8000);

	if ( szIcon != "" ) {
	    wnd_loct(0x801,3);
	    wnd_bitmap(szIcon,0x407f,0,0,0xFFFFFFL);
	    textout(0x0800+nLine,12,nChar|(nLine<<8),szMsg);
	}
	else
	    textout(0x0800+nLine,4,nChar|(nLine<<8),szMsg);

	rBase = 0x0802+nLine;
	cBase = wnd[3]/2;
	bBtn1 = bBtn2 = bBtn3 = 0;

	switch(nType&MB_TYPEMASK) {
	  case MB_OK:	nBtn = 1;
		bBtn1 = wnd_button(rBase,cBase-4,0x108,BTN_ATRB,szOkay);
		bBtnID[0] = IDOK;
		break;
	  case MB_YESNOCANCEL:	nBtn = 3;
		bBtn1 = wnd_button(rBase,cBase-16,0x108,BTN_ATRB,szYes);
		bBtnID[0] = IDYES;
		bBtn2 = wnd_button(rBase,cBase-4,0x108,BTN_ATRB,szNo);
		bBtnID[1] = IDNO;
		bBtn3 = wnd_button(rBase,cBase+8,0x108,BTN_ATRB,szCancel);
		bBtnID[2] = IDCANCEL;
		break;
	  case MB_YESNO:	nBtn = 2;
		bBtn1 = wnd_button(rBase,cBase-10,0x108,BTN_ATRB,szYes);
		bBtnID[0] = IDYES;
		bBtn2 = wnd_button(rBase,cBase+2,0x108,BTN_ATRB,szNo);
		bBtnID[1] = IDNO;
		break;
	  case MB_OKCANCEL:	nBtn = 2;
	  default:		nBtn = 2;
		bBtn1 = wnd_button(rBase,cBase-10,0x108,BTN_ATRB,szOkay);
		bBtnID[0] = IDOK;
		bBtn2 = wnd_button(rBase,cBase+2,0x108,BTN_ATRB,szCancel);
		bBtnID[1] = IDCANCEL;
		break;
	}
	redraw(wid);
	st_atrb = atrb;  st_atrbz = atrbz;
	for(;;) {
	    i = wnd_gbtn(0xf000);	// Application Modal
	    switch(i) {
	      case 0:
	      case -1:
		wndclose();
		return bBtnID[nBtn-1];
	      case bBtn1:
		wndclose();
		return bBtnID[0];
	      case bBtn2:
		wndclose();
		return bBtnID[1];
	      case bBtn3:
		wndclose();
		return bBtnID[2];
	    }
	}
}

